;;;;; AUTO PRODUCTION PROFIT MODEL
;; DATE       ;; Ver. ;; By  ;; Comments
;; 2007-09-?? ;;      ;; jps ;; email frm rg with spreadsheet with module data 
;; 2007-10-19 ;;      ;; jps ;; rcvd ppr frm rg
;; 2007-10-11 ;;      ;; jps ;; pc w/ rg -- discussed basic structure
;; 2007-10-12 ;;      ;; jps ;; preliminary code skeleton, comment sections
;; 2007-10-12 ;; 0001 ;; jps ;; note: using active comments formatting
;; 2007-10-15 ;; 0002 ;; jps ;; massaged advisor data
;; 2007-10-20 ;; 0003 ;; jps ;; begain integrating notes, initialization code near complete, some display code
;; 2007-10-22 ;; 0004 ;; jps ;; removed some skeleton sections that were superfluous
;;            ;;      ;;     ;; consumer perceived utility calculations
;; 2007-10-23 ;; 0005 ;; jps ;; added consumer purchasing module, scaled consumer agents
;;            ;;      ;;     ;; added preliminary selection model
;; 2007-10-24 ;; 0006 ;; jps ;; refactored production code to use "factory"
;;                           ;; idea is that production run can be expressed as a single parameter -- a list
;;                           ;; the list controls which design, production, and pricing modules to use
;; 2007-10-24 ;; 0007 ;; jps ;; modified test competition model--sometimes a no-profit design is kept
;; 2007-10-25 ;; 0008 ;; jps ;; fixed production qty module (prod-qty = demand = units-sold 
;;                           ;; fixed vis--slightly more sane
;;                           ;; added units-mfd-guess -- pricing module uses this quess of needed qty to set retail price
;;                           ;; QUESTION: Since this is not a pure two-player model, and since profit is not solely determined by
;;                           ;; module design (i.e. costs are module-design + investment-cost)
;;                           ;; and price is further affected by mfg volume ( must have sufficient volume and markup
;;                           ;; to offset investment-costs), then just optimizing on x1 x2 seems impossible!
;;                           ;; In other words, there are really x1 x2 x3 x4...
;;                           ;; module-scale, drive-ratio, investment-cost, production-volume-error
;;                       jps ;; added market share history, mean market-share-history used to predict market share
;;                           ;; corrected profit-loss functions to not count per-unit mfg costs agains units MFD (i.e. units-sold)
;;                           ;; fixed bugs in pricing model
;;                           ;; added plots
;;                           ;; added competitors slider
;;                           ;; markup is now an entry field
;; 2007-10-26 ;; 0009 ;; jps ;; huge edits to design creation system, simplified
;; ---- 11-05 ;; 0010 ;;     ;; added markup% as a production variable
;;                           ;; revised history-record creation method/timing
;;                           ;; created product.tweak=... procedures, e.g. product.tweak=keep-if-better-than-parent
;;                           ;; got clarification on which factors are important
;;                           ;; eliminated design-change-cost ( design integration cost) from pricing
;;                           ;; pricing is strictly unit-cost + markup
;;                           ;; added plots for per producer markup and cost
;;                           ;; added text format helpers
;;                           ;; improved visualization appearance/function
;;                           ;; added module-cost-table (precalculate module-design costs)
;;                           ;; considering added pre-calculated utility table, or
;; 11-14          0011       ;; conference call.
;;                           ;; assorted obsolete variables removed
;;                           ;; additional comments added, more needed
;; 11-16          0012       ;; added test-products breed
;;                           ;; started nash-equillibrium framework
;; 11-19                     ;; added lots more comments, more needed
;;                           ;; overhauled naming scheme for procedures somewhat
;;                           ;; modified tweak procedure to try to take market share into account (still very nieve)
;;                           ;; corrected error in plots setup
;;                           ;; more nash work -- major rethink... 
;; 11-26                     ;; more nash equ stuff
;;                           ;; more name correction
;; 11-28                     ;; patches now contain x1,x2, z1, z2, module cost information
;;                           ;; corrected product display
;; 11-29          0013       ;; more nash work
;;                           ;; patches now also contain utility calculations
;;                           ;; GRID-PATCHES contain patches that are part of the "design grid"
;; 11-30                     ;; more nash work--
;; 04-05-2008 - 04-10        ;; adding in GA and SA

;; 05-24-2008           Ting ;; re-write the GA
;;                 v3        ;; and use the total profit instead of profit, set markup% constant 20%
;;                 v4        ;; markup% not fixed
;;                 v5        ;; change back to profit
;;                           ;; both GA and SA works well
;;                 v6        ;; gasoline and diesel modules
                             ;; each producer can has more than one products, but here still set it 1
                             ;; both GA and SA works well to select module         
;;                 v7        ;; two different groups consumers 
;;                 v8        ;; add the policies chooser, CAFE and CO2 tax             
;; significant refactoring, cleaned up a lot of messy code
;; clarified procedure names, removed noun.verb names from most things
;; re-purposed modules
;; made product-design parameters a little more sane
;; improved sanity of the consumer-choose-products procedures
;; implemented generic roulette-wheel selector function, used by GA and by consumer-choose-products
;; compiles, probably won't run meaningfully
;; as strategy selection isn't implemented

;; =============================================== ;;
;; :: TO DO :: TO DO :: TO DO :: TO DO :: TO DO :: ;; 
;; =============================================== ;;
;; take GA one step further, need to actually run simulated market with consumers vs competition
;; and calculate actual profit, not just utility, to prevent fall in markup to 0, which actually makes everybody LOSE profits.
;;

;; implmement strategy selection fully
;; implement plann/produce phase
;; implememnt SA strategy


;;;  ========================================
;;;  ========================================
;;;
;;;              G L O B A L S
;;;
;;;  ========================================
;;;  ========================================

globals
[ ;; module related globals
  x1-list ;; this is the list of discrete module scale (x1) values that head the columns of the mpg and acc (z1) (z2) tables.
  x2-list  ;; this is the list of discrete drive ratio (x2) values that head the ROWS of the mpg and acc (z1) (z2) lists.
  module-power-list ;; this is the list of discrete module power values that correlate to module-scale (x1)
  x1-min ;; the minimum x1 value
  x1-max ;; the maximum x1 value
  x1-span ;; the span of the possible x1 values
  x2-min ;; the minimum x1 value
  x2-max ;; the maximum x1 value
  x2-span ;; the span of the possible x1 values
  
  
  min-module-cost ;; the minimum possible module cost (calculated)
  max-module-cost ;; the maximum possible module cost (calculated)
  
  ;; these two variables are calculated once and used whenever the length of the lists are needed, rather than repeatedly using the length reporter
  x1-list-length ;; the number of items in the module scale list. It is, therefore, also the number of columns in the z1,z2 tables
  x2-list-length ;; the number of items in the drive-ratio list. Also, therefore, the number of rows in the z1,z2 tables

  ;; these two variables are calculated once and used whenever the last index of the lists are needed, rather than repeatedly using the length reporter, minus 1
  x1-index-max ;; the maximum index of the module-scale list
  x2-index-max ;; the maximum index of the drive-ratio list
 
  x1-index-min
  x2-index-min
  
  x1-index-span
  x2-index-span
    
  ;; producer globals
  investment-base-cost ;; C^I,  is now ignored
  unit-mfg-base-cost ;; C^B,  base cost of a car design, before module cost

  ;; product globals
  
  product-list ;; the set of all current products, in list form. Membership is #-of-competitors x #-of-products-per-competitor
  prod-index-list ;; a list of numbers from [ 0 .. (length product-list - 1) ]
  
  ;; display globals
  ;; these are used only to facilitate the graph in the view
  ; med-pick
  grid-patches
  
  ;consumer.utility.beta1.mean ;; consumer demand utility function coefficients
  ;consumer.utility.beta2.mean
  ;consumer.utility.beta3.mean
  
  ;consumer.utility.beta1.sv
  ;consumer.utility.beta2.sv
  ;consumer.utility.beta3.sv
  
  markup%-span
  
  far_nbr_prob
  links_per_consumer
  
  month
  
  
]

;; patch variables are currently used only to faciliate the graph in the view
;; but might eventually be used as a convinient way to store the z1, z2 values, and also
;; the calculated module-costs, and the calculated utility values

to ...patches-own... end

patches-own
[
  ;; used for display purposes
  pick
  
  ;; there are the same, or more, patches, than the contents of the mpg and accel tables for both modules
  ;; so the patches act as cells in these tables (i.e., each patch is a cell of the table
  ;; so patch 1 2 contains the data for column 1, row 2 of the table)
  ;; also, the utility calculations for all combinations of x1, x2, with 0% profit.
  p-x1-index ;; the column of this cell in the x1,x2,z1,z2 tables (same a pxcor)
  p-x2-index ;; the row of this patch in the z1, z2, tables
  p-x1   ;; the value of x1 for this cell
  p-x2   ;; the value of x2 for this cell
  p-z1-g ;; the value of z1 for the gas module
  p-z2-g ;; the value of z2 for the gas module
  p-z1-d ;; the value of z1 for the desiel module
  p-z2-d ;; the value of z2 for the desiel module
  p-e-cost-g ;; the calculated gas module design cost
  p-e-cost-d ;; the caluclated desiel module design cost
  p-e-price-g ;; the calculated gas module vehicle base price (no markup)
  p-e-price-d ;; the calculated desiel module vehicle base price (no markup)
  p-b-utility-g ;; the calculated base gase module utility (does not include the retial price term, only z1, z2)
  p-b-utility-d ;; the calculated base desiel module utility (does not include the retial price term, only z1, z2)
  p-utility-g ;; the calculated utility perception (including a retail price term) for the gas module
  p-utility-d ;; the calculated utility perception (including a retail price term) for the desiel module
  payoff ;; used in the nach equilibrium finder... is set to the p-utility... value that should be considered
]

;;;  ========================================
;;;  ========================================
;;;
;;;                 B R E E D S
;;;
;;;  ========================================

breed [ producers producer ] ; producers make products
breed [ consumers consumer ] ; consumers purchase products
breed [ products product ] ; products are made by producers, bought by consumers, contain modules
breed [ modules module ]   ; modules store the module (e,g, gas or desiel) specific paramaters, are referenced by products
breed [ product-histories product-history ] ;; a product history record
breed [ tuples tuple ] ;; a turtle that contains a pair of values, in a table-like arrangement, used to calculate nash equilibrium

;;;  ========================================
;;;
;;;        PRODUCERS -OWN
;;;
;;;  ========================================


to ...producers-own... end

producers-own
[ producer-id ;; set to self, inherited by products
  producer#
  name ;; text name for producer for easier comprehension
  model# ;; the next model number to be assigned
  market-share ;;  a percentage, producers belief about how many consumers would choose this producers products
  ;; starts at  1 / number-of-producers, then is set to the market share produced in the previous iteration
  market-share-history
    
  ;; these are the tallies for the entire run
  t-profit     ;; profit = (all revenue - all costs)
  t-revenue    ;; revenue = (sum of all sales)
  t-costs      ;; all costs 
  t-units-sold ;; number of sales (to calulate average price/profit)
  t-investment-cost ;; design/development cost
  t-unit-mfg-cost ;; total per-unit costs
  t-prod-cost  ;; production cost

  ; t-reg-cost   ;; regulatory cost
  ; t-mark-cost  ;; marketing cost (includes all phases)
  
  ;; these are the tallies for the current period (e.g. year-to-date)
  p-profit    
  p-revenue   
  p-costs     
  p-units-sold
  p-investment-cost
  p-unit-mfg-cost
  p-prod-cost 
  

  
  ; p-reg-cost
  ; p-mark-cost
  
  product-line ;; agentset of current products  
  last-year-product-line ;; agentset of last-year's products
  all-product-line
  
  strategy
]

;;;  ========================================
;;;
;;;         C O N S U M E R S -OWN
;;;
;;;  ========================================

to ...consumer...variables end

consumers-own
[ scale ;; how many individuals does this agent represent
  ; product list is clobal
  product-selection ;; the product selected by this consumer agent, this turn/tick/year
  
  ;utility.beta1
  ;utility.beta2
  ;utility.beta3


  sample_num                ;= ?
  
  coupe_pw                  ;= partworth for coupe
  sedan_pw                  ;= partworth for sedan
  suv_pw                    ;= partworth for suv
  hatchback_pw              ;= partworth for hatchback
  car_type_pw
  
  policy1_pw                ;= partworth for policy 1: tax rebate for plug-in and gas-electric hybrid vehicles
  policy2_pw                ;= partworth for policy 2: tax rebate for electric vehicles
  policy3_pw                ;= partworth for policy 3: subsidy for biodiesel
  policy4_pw                ;= partworth for policy 4: subsidy for diesel
  policy5_pw                ;= partworth for policy 5: green fee for suv
  policy6_pw                ;= partworth for policy 6: green fee for gas-only vehicle
  policy7_pw                ;= partworth for policy 7: none policy
  policy_pw
  
  gasoline_pw               ;= partworth for gasoline
  diesel_pw                 ;= partworth for diesel
  biodiesel_pw              ;= partworth for biodiesel
  geh_pw                    ;= partworth for gas-electric hybrid
  phe_pw                    ;= partworth for plug-in hybrid electric
  electric_pw               ;= partworth for electric
  fuel_type_pw
  
  mpg_low_pw                ;= partworth for below 19 mpg
  mpg_med_pw                ;= partworth for 20-29 mpg
  mpg_more_pw               ;= partworth for 30-39 mpg
  mpg_most_pw               ;= partworth for above 40 mpg
  mpg_pw
  
  mpc_low_pw                ;= partworth for below 50 miles per charge
  mpc_med_pw                ;= partworth for 51-100 mpc
  mpc_more_pw               ;= adjusted stelvin 101-150 mpc
  mpc_most_pw               ;= partworth for above 151 mpc
  mpc_pw
  
  price_low_pw              ;= partworth for below $20,000
  price_med_pw              ;= partworth for $20,001-30,000
  price_more_pw             ;= partworth for $30,001-40,000
  price_most_pw             ;= partworth for above $40,001
  price_pw
  
  none_pw                   ;= partworth for none
  
  advertising
  innovativeness
  knowledge
  womcount
  
  purchasing                ;= the number of vehicle to buy, 0 means no purchasing
  nbrs                      ;= a list of ids of all neighbors of the consumer
  monthleft                 ;= after these months to change a new vehicle, abay uniform distribution
                            ;= assume each consumer change the vehicle every 60 months (5 years)
  adoption                  ; consumer's adoption of module number
]

;;;  ========================================
;;;
;;;         P R O D U C T S -OWN
;;;
;;;  ========================================

to ...products-own... end

products-own
[ producer-id ;; reference to the producer
  
  name ;; human-readable name of this product (a number), based on a sequential model number maintained by the producer
  
  product-year ;; the "year" the product is current
  
  x1-index ;; a number from 0 to 12, the index of the module-scale factor
  x2-index ;; a number from 0 to 19, the index of the final-drive-ratio factor
  
  x1 ;; the value of the module scale
  x2 ;; the value of the final drive ratio
  
  z1 ;; the looked-up value of mpg from mpg table, using scale and ratio indexes
  z2 ;; the looked-up value of accel from accel table, using scale and ratio indexes
  
  module-type ;; used to get the module-id
  module-id ;; a link to the module table for this product
  
  module-change?
  
  markup%
   
  module-cost
  
  investment-cost ;; 
  
  
  
  unit-mfg-cost ;; per-unit manufacturing cost (e.g. consumables, materials, labor ) (does not unclude overall design costs)
  
  unit-regu-cost
  
  unit-net-cost ;; total costs / total number mfg.
  
  
  
  retail-price ;; per-unit retail price
  utility ;; utility score for this design, the result of x1, x2, and price (from markup%)
  probability ;; the probability score assigned this design, (utility ^ 2)
  utility2
  probability2
  
  units-sold ;; number of units sold
  
  costs   ;; total of all costs for this production run
  revenue ;; total of all revenue for this production run
  profit  ;; calculated profit for this production run
  market-share ;; net market-share (percent of all sales) for this product
  
  total-profit
  sum-utility  ;; all the consumer's utility for this product
  total-utility
  
]

to ...modules-own... end

modules-own
[ 
  fuel      ;; e.g. gas or hybrid or electric
  cartype   ;;Sedan or SUV
  module#
  power
  cost-parameter-a
  cost-parameter-b
  cost-function
  z1-table
  z2-table
  e-cost-table ;; the pre-calculated cost to produce this module with a given x1-index
  
]

to ...tuples-own... end

tuples-own
[ source-a
  source-b
  payoff-id ;; identifies the payoff matrix containing this tuple
  row
  col
  payoff-a
  payoff-b
  is-col-max?
  is-row-max?
]



;;;  --------------------------------------------------------------------------------
;;;  --------------------------------------------------------------------------------
;;; |
;;;    C O D E   S E C T I O N
;;; |
;;;  --------------------------------------------------------------------------------
;;;  --------------------------------------------------------------------------------

;;;  ----------------------------------------
;;;
;;;                 SETUP
;;;
;;;  ----------------------------------------

to __setup__

   clear-all
   
   __setup_global_constants
   
   setup-modules
   setup-display
   setup-producers
   setup-products
   setup-consumers
   plot...setup ; set up the plots used by the producers
   
   color-patches-by-utility
   ;ask patch 8 11 [ set pcolor red ]
   V&V
   ;run-real-market-with ( turtle-set [product-line] of producers )
   
end

;;;  ----------------------------------------
;;;
;;;                   GO 
;;;
;;;  ----------------------------------------

to __go__

   tick
   set month month + 1
   
   if experiment = "CAFE" and month = 51
   [set policy-choice "CAFE"]
   
   if experiment = "Rebate" and month = 51
   [set consumer-policy "Tax Rebate for Hybrid"]
   
   if experiment = "GreenFee" and month = 51
   [set consumer-policy "Green Fee for Gasoline"]
   
   if experiment = "CAFE+GreenFee"
   [if month = 51
     [set policy-choice "CAFE"]
    if month = 101
     [set consumer-policy "Green Fee for Gasoline"]   
   ]
   
   if experiment = "CAFE+Rebate"
   [if month = 51
     [set policy-choice "CAFE"]
    if month = 101
     [set consumer-policy "Tax Rebate for Hybrid"]   
   ]
   
   production-phase  ;; product are manufactured
   competition-phase ;; marketing ==> consumer demand ==> sales
   analysis-phase    ;; sales performance is measured, logged
   ;r&d-phase ;; r&d dollars create new features
   ;regulatory-phase  ;; legislative action requires new features = new costs
   ;; patches.update-pick-graph
   
end

to go_400

   ;; save the state of the output switch
   let save-output output?
   ;; force text output to false
   set output? false
   
   ;; run 1000 times
   repeat 400 [ __go__ ]
   
   ;; restore state of the output switch
   set output? save-output

end



;;;  ----------------------------------------
;;;
;;;        SETUP-PRODUCERS
;;;
;;;  ----------------------------------------

to __setup_global_constants
   set month 0
   
   set investment-base-cost 0 ; 550E6 
   set unit-mfg-base-cost 7500 
   
   set consumer-policy "None Policy"
   set policy-choice "none policy"
   
   set far_nbr_prob 0.2        ;= Small-world network factor - the probability that a neighbor will be outside of the local (close proximity) network
   set links_per_consumer 2
   
   ;; the following constants were provided in the literature
   ;set consumer.utility.beta1.mean    -2.86e-4 
   ;set consumer.utility.beta2.mean    -0.339
   ;set consumer.utility.beta3.mean     0.375
   
   ;set consumer.utility.beta1.sv    0.5e-4
   ;set consumer.utility.beta2.sv    0.1
   ;set consumer.utility.beta3.sv    0.1
   
end

to setup-producers
   
   let producer-names n-values competitors [word "p" (? + 1)]       ; define some producer names for visualization
   let producer#-list n-values competitors [ ? + 1 ]
   let number-of-producers competitors ;; copy the value from the competitors slider, so changing the slider during simulation doesn't cause wierd effects
   let strategies [ "drunken-ceo" "genetic-algorithm" "simulated-annealing" ]
   let strat-count length strategies
   let all-strats n-values number-of-producers [ item ( ? mod strat-count ) strategies ]
   
   create-producers number-of-producers  ; create the desired number of producer agents
   [ ;; display stuff
     turtle.hide                                     ; hide the agent visually (display of producers is not required)
     
     ;; model stuff
     set producer-id self                            ; for a producer, contains the id of the producer itself.
                                                     ; this is so that all products created by this producer automatically inherit the producer id
     set model# 1                                    ; model# is a sequence or version number. First product is model# 1, next is model# 2... 
                                                     ; each producer maintains it's own sequence numbers
     set name first producer-names                   ; simply to make it easier to refer to the producers, rather than by who numbers
     set producer-names but-first producer-names     ; removes that name from the list of names, so it is not reused.
     
     set producer# first producer#-list
     set producer#-list but-first producer#-list
     
     set last-year-product-line no-turtles
     set product-line no-turtles                     ; initialize the product line (there are no products)
     set all-product-line no-turtles
     
     set market-share-history []                     ; initialize the market-share-history
     set market-share 0                              ; initialize the market-share
     
     set strategy competition-strategy;first all-strats
    ; set all-strats but-first all-strats     
   ]

end

to plot...setup

   ask producers
   [ ;; each producer adds itself to the plot, if needed, and sets the color of it's plot pen
     set-current-plot "Profit"
     if not plot-pen-exists? name [ create-temporary-plot-pen name ]
     set-current-plot-pen name
     ;set-plot-pen-color 15 + 10 * read-from-string last name
     
     ;set-current-plot "Total Profit"
    ; if not plot-pen-exists? name [ create-temporary-plot-pen name ]
    ; set-current-plot-pen name
    ; set-plot-pen-color 15 + 10 * read-from-string last name
     
     set-current-plot "Markup"
     if not plot-pen-exists? name [ create-temporary-plot-pen name ]
     set-current-plot-pen name
     ;set-plot-pen-color 15 + 10 * read-from-string last name

     set-current-plot "Sales"
     if not plot-pen-exists? name [ create-temporary-plot-pen name ]
     set-current-plot-pen name
     ;set-plot-pen-color 15 + 10 * read-from-string last name
     
     
     set-current-plot "Market Share"
     if not plot-pen-exists? name [ create-temporary-plot-pen name ]
     set-current-plot-pen name
     ;set-plot-pen-color 15 + 10 * read-from-string last name
   ]
   
   ask modules
   [
     set-current-plot "Sales by Module"
     if not plot-pen-exists? word fuel cartype [ create-temporary-plot-pen word fuel cartype ]
     set-current-plot-pen word fuel cartype   
   
   ]
  
end

  
   
;;;  ----------------------------------------
;;;
;;;        SETUP - P R O D U C T S
;;;
;;;  ----------------------------------------

to setup-products
     ;; each producer adds (products-per-competitor) models  to the product line
     ask producers
     [ let whomakeme self
       repeat products-per-competitor
       [ ask new-product 
         [ 
           turtle.hide
           ;apply-random-product-design-and-price
           increment-model-number-and-set-model-name
           apply-constant-product-design-and-price (whomakeme)
           add-product-to-product-line
         ]
       ]

       ;ask product-line [ product.display product.output-product-info ]
     ]
     
   let producers-by-name producer.all-sorted-by-name
  
   foreach producers-by-name
   [
     ask [product-line] of ?
     [ product.display 
     product.output-product-info 
     set pick pick + 1 
     ]
   ]
   global:update-product-list
end

to-report new-product
   ;; always should be run by a producer, or an existing product
   ;; (so that producer-id is already set)
   let me nobody
   hatch-products 1
   [ ;; note: producer-id inherited from progenitor
     
     
     set name "null"
     
     ;; note: all design-specific parameters are not set here
     ;; must run "apply-random-design" or set design parameters specifically
     ;; if created by an existing product, using "hatch", this product will
     ;; have identical parameters to existing product
     ;; but results fields will be zeroed
     
     set units-sold 0
     set profit 0
     set revenue 0
     set me self
   ]
   report me
end    

to-report random-x1
   report x1-index-min + random-float (x1-index-span)
end

to-report random-x2
   report x2-index-min + random-float (x2-index-span)
end

to-report random-markup
   report markup%-min + random-float markup%-span   
end

to apply-random-product-design-and-price
   ; set module-id one-of modules  
   set module-id one-of modules ;with [ fuel = "gas" ]
   set module-type [fuel] of module-id
   set x1-index random x1-list-length
   set x2-index random x2-list-length
   set markup% random-markup
   calculate-secondary-design-values
end   

to apply-constant-product-design-and-price [whomakeme]

   set module-id one-of modules with [module# = [producer#] of whomakeme]
   set module-type [fuel] of module-id
   set x1-index 5
   set x2-index 5
   set markup% 10
   calculate-secondary-design-values

end 
  
to apply-product-parameters [ parameter-list ]
   ;; applies the provided parameters to the product
   ;; and calculates secondary values
   ;; parameter-list is a list containing x1-index, x2-index, and markup%, in that order
   set module-id one-of modules with [ module# = first parameter-list ]
   set module-type [fuel] of module-id
   set x1-index item 1 parameter-list
   set x2-index item 2 parameter-list
   set markup% last parameter-list
   calculate-secondary-design-values
end  

to calculate-secondary-design-values
   ;; given that the x1-index, x2-index, and markup have been set, 
   ;; calculate or lookup the values that depend on those
   set x1 x1-lookup x1-index
   set x2 x2-lookup x2-index
   set z1 z1-lookup x1-index x2-index module-id
   set z2 z2-lookup x1-index x2-index module-id
   calculate-module-cost
   calculate-price

end

to calculate-module-cost 
   ;; reports the cost of the module, using the modules design cost function
   let result 0
   let #x1 x1-index
   let #x2 x2-index
   ask module-id
   [ set result z2-lookup #x1 #x2 self  ;;item #x1 e-cost-table;#run-result (word cost-function " " #x1 )
   ]
   set module-cost result
   
   ifelse policy-choice = "CAFE"
     [set unit-regu-cost max list 0 (55 * ( 31.6 - z1))]
     [ ifelse policy-choice = "CO2 tax"
       [ifelse module-type != "Electric"
         [set unit-regu-cost 15 * 150000 * 0.00994 / z1 ]
         [set unit-regu-cost 0];;15 * 150000 * 0.00921 / z1 ]
       ]
       [ ifelse policy-choice = "Both"
         [ set unit-regu-cost max list 0 (55 * (31.6 - z1))
           ifelse module-type != "Electric"
           [set unit-regu-cost unit-regu-cost + 15 * 150000 * 0.00994 / z1 ]
           [set unit-regu-cost unit-regu-cost + 0] ;;15 * 150000 * 0.00921 / z1 ]
         ]
         [set unit-regu-cost 0]
       ]
     ]
     
end

to calculate-price
     ;; calculate costs and pricing using new markup amount
     set unit-mfg-cost module-cost
     set retail-price unit-mfg-cost * (1 + .01 * markup%)
end


to calculate-utility [ chooser ]
   ;; calculate the percieved utility of this design
   ;; (see setup-consumers for values of beta 1, 2, 3
    let temp_utility 0
          set utility 0
         ; set probability 0
          
          ifelse [cartype] of module-id = "Sedan"
          [set temp_utility item 1 [car_type_pw] of chooser]  ;;sedan partworth
          [set temp_utility item 2 [car_type_pw] of chooser]  ;;SUV partworth
          set utility utility + temp_utility
          
          ;set temp_utility item (policy - 1) [policy_pw] of myself 
          ;set utility utility + temp_utility
          
          ifelse [fuel] of module-id = "Gasoline"
          [set temp_utility item 0 [fuel_type_pw] of chooser] ;;gasoline vehicle partworth
          [ifelse [fuel] of module-id = "Hybrid"
           [set temp_utility item 3 [fuel_type_pw] of chooser] ;;hybrid vehicle partworth
           [set temp_utility item 5 [fuel_type_pw] of chooser] ;;electric vehicle partworth
          ]

          set utility utility + temp_utility
        
          ifelse [fuel] of module-id != "Electric"
          [ ifelse z1 <= 19
            [set temp_utility [mpg_low_pw] of chooser]
            [ifelse z1 > 19 and z1 <= 24.5
              [set temp_utility [mpg_low_pw] of chooser + (z1 - 19) * ([mpg_med_pw] of chooser - [mpg_low_pw] of chooser) / 5.5]
              [ifelse z1 > 24.5 and z1 <= 34.5
                [set temp_utility [mpg_med_pw] of chooser + (z1 - 24.5) * ([mpg_more_pw] of chooser - [mpg_med_pw] of chooser) / 10]
                [ifelse z1 > 34.5 and z1 <= 40
                  [set temp_utility [mpg_more_pw] of chooser + (z1 - 34.5) * ([mpg_most_pw] of chooser - [mpg_more_pw] of chooser) / 5.5]
                  [set temp_utility [mpg_most_pw] of chooser]              
                ]            
              ] 
            ]
          ]
          [ ifelse z1 <= 50
            [set temp_utility [mpc_low_pw] of chooser]
            [ifelse z1 > 50 and z1 <= 75
              [set temp_utility [mpc_low_pw] of chooser + (z1 - 50) * ([mpc_med_pw] of chooser - [mpc_low_pw] of chooser) / 25]
              [ifelse z1 > 75 and z1 <= 125
                [set temp_utility [mpc_med_pw] of chooser + (z1 - 75) * ([mpc_more_pw] of chooser - [mpc_med_pw] of chooser) / 50]
                [ifelse z1 > 125 and z1 <= 150
                  [set temp_utility [mpc_more_pw] of chooser + (z1 - 125) * ([mpc_most_pw] of chooser - [mpc_more_pw] of chooser) / 25]
                  [set temp_utility [mpc_most_pw] of chooser]              
                ]            
              ] 
            ]        
          ]
          set utility utility + temp_utility
          ifelse ( consumer-policy = "Tax Rebate for Hybrid" and [fuel] of module-id = "Hybrid" ) or
                 ( consumer-policy = "Tax Rebate for Electric" and [fuel] of module-id = "Electric" )
          [ ifelse retail-price <= 25000
            [set temp_utility [price_med_pw] of chooser + (0.9 * retail-price - 25000) * ([price_med_pw] of chooser - [price_low_pw] of chooser) / 5000]
            [ifelse retail-price > 25000 and retail-price <= 35000
              [set temp_utility [price_med_pw] of chooser + (0.9 * retail-price - 25000) * ([price_more_pw] of chooser - [price_med_pw] of chooser) / 10000]
              [set temp_utility [price_more_pw] of chooser + (0.9 * retail-price - 35000) * ([price_most_pw] of chooser - [price_more_pw] of chooser) / 5000]            
            ]
          ]
          [ ifelse ( consumer-policy = "Green Fee for SUV" and [cartype] of module-id = "SUV" ) or
                   ( consumer-policy = "Green Fee for Gasoline" and [fuel] of module-id = "Gasoline" )
            [ifelse retail-price <= 25000
              [set temp_utility [price_med_pw] of chooser + (1.1 * retail-price - 25000) * ([price_med_pw] of chooser - [price_low_pw] of chooser) / 5000]
              [ifelse retail-price > 25000 and retail-price <= 35000
                [set temp_utility [price_med_pw] of chooser + (1.1 * retail-price - 25000) * ([price_more_pw] of chooser - [price_med_pw] of chooser) / 10000]
                [set temp_utility [price_more_pw] of chooser + (1.1 * retail-price - 35000) * ([price_most_pw] of chooser - [price_more_pw] of chooser) / 5000]            
              ]
            ]
            [ifelse retail-price <= 25000
              [set temp_utility [price_med_pw] of chooser + (retail-price - 25000) * ([price_med_pw] of chooser - [price_low_pw] of chooser) / 5000]
              [ifelse retail-price > 25000 and retail-price <= 35000
                [set temp_utility [price_med_pw] of chooser + (retail-price - 25000) * ([price_more_pw] of chooser - [price_med_pw] of chooser) / 10000]
                [set temp_utility [price_more_pw] of chooser + (retail-price - 35000) * ([price_most_pw] of chooser - [price_more_pw] of chooser) / 5000]            
              ] 
            ]      
          ]

          
          set utility utility + temp_utility 
          
          ifelse consumer-policy = "Tax Rebate for Hybrid"
          [ifelse [fuel] of module-id = "Hybrid"
            [set temp_utility [policy1_pw] of chooser]
            [set temp_utility 0]          
          ]
          [ifelse consumer-policy = "Tax Rebate for Electric"
           [ifelse [fuel] of module-id = "Electric"
             [set temp_utility [policy2_pw] of chooser]
             [set temp_utility 0]
           ]
           [ifelse consumer-policy = "Green Fee for SUV"
             [ifelse [cartype] of module-id = "SUV"
               [set temp_utility [policy5_pw] of chooser]
               [set temp_utility 0]             
             ]             
             [ifelse consumer-policy = "Green Fee for Gasoline"
               [ifelse [fuel] of module-id = "Gasoline"
                 [set temp_utility [policy6_pw] of chooser]
                 [set temp_utility 0]
               ]
               [set temp_utility [policy7_pw] of chooser]
             
             ]
           ]
          ]
          set utility utility + temp_utility
          let adop_module [module#] of module-id
          
          let nbr_set turtle-set [nbrs] of chooser          
          let adopt_ngbr count nbr_set with [adoption = adop_module]
          ;if [fuel] of module-id != "Gasoline"
          ;[set utility utility * (([advertising] of chooser + [knowledge] of chooser) * (1 - exp (-0.01 * [innovativeness] of chooser * month)) + adopt_ngbr * 0.125)]
          if length [nbrs] of chooser > 0
          [set utility beta * adopt_ngbr / (length [nbrs] of chooser) + (1 - beta) * utility]
          

end

to calculate-utility-for-v&v [chooser]

   let temp_utility 0
          set utility 0
         ; set probability 0
          
          ifelse [cartype] of module-id = "Sedan"
          [set temp_utility item 1 [car_type_pw] of chooser]  ;;sedan partworth
          [set temp_utility item 2 [car_type_pw] of chooser]  ;;SUV partworth
          set utility utility + temp_utility
          
          ;set temp_utility item 6 [policy_pw] of chooser
          ;set utility utility + temp_utility
          
          ifelse [fuel] of module-id = "Gasoline"
          [set temp_utility item 0 [fuel_type_pw] of chooser] ;;gasoline vehicle partworth
          [ifelse [fuel] of module-id = "Hybrid"
           [set temp_utility item 3 [fuel_type_pw] of chooser] ;;hybrid vehicle partworth
           [set temp_utility item 5 [fuel_type_pw] of chooser] ;;electric vehicle partworth
          ]

          set utility utility + temp_utility
        
          ifelse [fuel] of module-id != "Electric"
          [ ifelse z1 <= 19
            [set temp_utility [mpg_low_pw] of chooser]
            [ifelse z1 > 19 and z1 <= 29
              [set temp_utility [mpg_med_pw] of chooser]
              [ifelse z1 > 29 and z1 <= 39
                [set temp_utility [mpg_more_pw] of chooser]
                [set temp_utility [mpg_most_pw] of chooser]              
              ] 
            ]
          ]
          [ ifelse z1 <= 50
            [set temp_utility [mpc_low_pw] of chooser]
            [ifelse z1 > 50 and z1 <= 100
              [set temp_utility [mpc_med_pw] of chooser]
              [ifelse z1 > 100 and z1 <= 150
                [set temp_utility [mpc_more_pw] of chooser]
                [set temp_utility [mpc_most_pw] of chooser]              
              ] 
            ]        
          ]
          set utility utility + temp_utility
          ifelse retail-price <= 20000
          [set temp_utility [price_low_pw] of chooser]
          [ifelse retail-price > 20000 and retail-price <= 30000
            [set temp_utility [price_med_pw] of chooser]
            [ifelse retail-price > 30000 and retail-price <= 40000
              [set temp_utility [price_more_pw] of chooser]
              [set temp_utility [price_most_pw] of chooser]              
            ]
          ]
          set utility utility + temp_utility 
          
          ifelse consumer-policy = "Tax Rebate for Hybrid"
          [ifelse [fuel] of module-id = "Hybrid"
            [set temp_utility [policy1_pw] of chooser]
            [set temp_utility 0]          
          ]
          [ifelse consumer-policy = "Tax Rebate for Electric"
           [ifelse [fuel] of module-id = "Electric"
             [set temp_utility [policy2_pw] of chooser]
             [set temp_utility 0]
           ]
           [ifelse consumer-policy = "Green Fee for SUV"
             [ifelse [cartype] of module-id = "SUV"
               [set temp_utility [policy5_pw] of chooser]
               [set temp_utility 0]             
             ]             
             [ifelse consumer-policy = "Green Fee for Gasoline"
               [ifelse [fuel] of module-id = "Gasoline"
                 [set temp_utility [policy6_pw] of chooser]
                 [set temp_utility 0]
               ]
               [set temp_utility [policy7_pw] of chooser]
             
             ]
           ]
          ]
          set utility utility + temp_utility
end

to V&V

  let vehicles turtle-set [product-line] of producers
  
  ask consumers
  [
      ask vehicles
     [
         calculate-utility-for-v&v myself
         calculate-probability
     ]
     
     ifelse choice-method = "share of preference"
       [let me nobody
       if None-option?
       [
         hatch-products 1
         [ 
          set probability e ^ [none_pw] of myself
          set me self     
         ]
         set vehicles (turtle-set vehicles me)
       ]
     
       let choices-list sort vehicles
       set choices-list shuffle choices-list
   
       let total-prob sum map [ [ probability ] of ? ] choices-list
       let n random-float total-prob 
       let selected first choices-list
       let i [ probability ] of selected
       while [ i < n ]
       [ ;; discard current item
         set choices-list but-first choices-list
         set selected first choices-list
         set i i + [ probability ] of selected
       ]
     
       ifelse None-option?
       [ ifelse selected != me
         [ask selected [set units-sold units-sold + 1 ] 
          set adoption [module#] of [module-id] of selected
         ]
         [set adoption 0]
         ask me [die]
       ]
       [ask selected [set units-sold units-sold + 1 ] 
        set adoption [module#] of [module-id] of selected
       ]
       
     ]
     [
       let chosen_vehicle first sort-by [ [utility] of ?1 > [utility] of ?2 ] vehicles
       ifelse None-option?
       [ifelse [utility] of chosen_vehicle >= [none_pw] of self
         [ ask chosen_vehicle  [ set units-sold units-sold + 1 ]
           set adoption [module#] of [module-id] of chosen_vehicle       
         ]
         [set adoption 0]
       ]
       [ask chosen_vehicle  [ set units-sold units-sold + 1 ] 
        set adoption [module#] of [module-id] of chosen_vehicle
       ]
     ]
  ]
  
  ask vehicles [calculate-profit-for-product]
  
  calculate-market-share-for-products
  
  p "###############Verification & Validation#################"
  
   let producers-by-name producer.all-sorted-by-name
   let #sold 0
   foreach producers-by-name
   [
     ask [product-line] of ?
     [ set #sold #sold + units-sold
       let marketshare100 market-share * 100
       p  (word name ", " [fuel] of module-id " " [cartype] of module-id ", " precision marketshare100 2 " %") 
     ]
   ]   
   p (word "None Purchase:" precision (100 * (market-size - #sold) / market-size) 2 " %" )
   p "#####################End of V&V#######################"
   
   ask vehicles [set units-sold 0]
end


to calculate-probability
   set probability e ^ utility
   ;set probability2 e ^ utility2
end   

to increment-model-number-and-set-model-name ;; product procedure
   ;; a product (usually a new product) increments the "next" model-number
   ;; of the producer--this is then used as the product's model name
   ;; this only happens to a product when it goes into "real" production 

   set name (word [ name ] of producer-id "/" [ model# ] of producer-id )
   ask producer-id [ set model# model# + 1 ]
end


to add-product-to-product-line

  ;; this 
   ask producer-id
   [ if not is-turtle-set? product-line
     [ set product-line no-turtles ]
     set product-line (turtle-set product-line myself)
     ;set all-product-line (turtle-set all-product-line myself)
   ]
end

to del-product-from-product-line

   let me self
   ask producer-id
   [ if not is-turtle-set? product-line
     [ set product-line no-turtles ]
     set product-line product-line with [ self != me ] 
   ]
end
     
to global:update-product-list     
   set product-list sort products
   set prod-index-list n-values count products [ ? ]
end



;to create-history-records
;   ask products
;   [ set breed product-histories
;     set timestamp ticks
;     turtle.hide
;   ]
;end

to product.display
   set size 2.5
   set label (word name "    ")
   set label-color black
   ifelse [cartype] of module-id = "Sedan"
   [set shape "car side"]
   [set shape "van side"]
   ifelse [fuel] of module-id = "Gasoline"
   [set color blue]
   [ifelse [fuel] of module-id = "Hybrid"   
     [set color green]
     [set color orange]
   ]
   setxy (x1-index) (x2-index )
   
   show-turtle
end

to product.output-product-info
   if not output? [ stop ]

   p  (word name "," [fuel] of module-id " " [cartype] of module-id "," precision z1 2 "," precision retail-price 2)
;   ;p  word "module:                  " [ (word name " ( " fuel "/" power ")") ] of module-id
;   ;p (word "x1//x2//markup//fuel type//car type:    " precision x1 5 "//" precision x2 5 "//" precision markup% 2 "//" [fuel] of module-id "//" [cartype] of module-id)
;   p [fuel] of module-id
;   p [cartype] of module-id
;   ;p (word "MPG/Manufacturing Cost(z1/z2):        " precision z1 5 "//" precision z2 5 )
;   ;p (word "unit mfg cost / regulation cost / retail price:   $" precision unit-mfg-cost 2 "  // $"precision unit-regu-cost 2"  // $"precision retail-price 2)
;   p precision retail-price 2
end

;;;  ----------------------------------------
;;;
;;;       CONSUMER SETUP
;;;
;;;  ----------------------------------------

to setup-consumers
   ;; Flexibly allows creation of consumer agents that can represent 1 to however-many indivisuals
   ;; 
   
   ;let #agent-scale 10 ^ agent-scale
   
  
   create-consumers floor market-size
   [ 
     set  scale 1
     turtle.hide
   ]
   
   let readcount 0

  set readcount 1                                                                      ; a counter to keep track of what line of data is being read from the spreadsheet
  file-open "NoGroup5NoGroup4_std_1st.txt"                                                                  ; open the spreadsheet - must be a space separated file, with 21 data entries per line
  without-interruption 
  [                                                               ; do the following sequentially
    ask consumers
    [                                                                    ; for all consumers...
      set purchasing 0                                                            ; set the initial adoption state to have not adopted STEL
      set sample_num file-read                                                           ; load occasion from spreadsheet (not used)
      set coupe_pw file-read                 ;= partworth for coupe
      set sedan_pw file-read                 ;= partworth for sedan
      set suv_pw file-read                   ;= partworth for suv
      set hatchback_pw file-read             ;= partworth for hatchback
      set car_type_pw (list coupe_pw sedan_pw suv_pw hatchback_pw)
       
      set policy1_pw file-read               ;= partworth for policy 1: tax rebate for plug-in and gas-electric hybrid vehicles
      set policy2_pw file-read               ;= partworth for policy 2: tax rebate for electric vehicles
      set policy3_pw file-read               ;= partworth for policy 3: subsidy for biodiesel
      set policy4_pw file-read               ;= partworth for policy 4: subsidy for diesel
      set policy5_pw file-read               ;= partworth for policy 5: green fee for suv
      set policy6_pw file-read               ;= partworth for policy 6: green fee for gas-only vehicle
      set policy7_pw file-read               ;= partworth for policy 7: none policy
      set policy_pw (list policy1_pw policy2_pw policy3_pw policy4_pw policy5_pw policy6_pw policy7_pw)
      
      set gasoline_pw file-read              ;= partworth for gasoline
      set diesel_pw file-read                ;= partworth for diesel
      set biodiesel_pw file-read             ;= partworth for biodiesel
      set geh_pw file-read                   ;= partworth for gas-electric hybrid
      set phe_pw file-read                   ;= partworth for plug-in hybrid electric
      set electric_pw file-read              ;= partworth for electric
      set fuel_type_pw (list gasoline_pw diesel_pw biodiesel_pw geh_pw phe_pw electric_pw)
      
      set mpg_low_pw file-read               ;= partworth for below 19 mpg
      set mpg_med_pw file-read               ;= partworth for 20-29 mpg
      set mpg_more_pw file-read              ;= partworth for 30-39 mpg
      set mpg_most_pw file-read              ;= partworth for above 40 mpg
      set mpg_pw (list mpg_low_pw mpg_med_pw mpg_more_pw mpg_most_pw)
      
      set mpc_low_pw file-read               ;= partworth for below 50 miles per charge
      set mpc_med_pw file-read               ;= partworth for 51-100 mpc
      set mpc_more_pw file-read              ;= adjusted stelvin 101-150 mpc
      set mpc_most_pw file-read              ;= partworth for above 151 mpc
      set mpc_pw (list mpc_low_pw mpc_med_pw mpc_more_pw mpc_most_pw)
      
      set price_low_pw file-read             ;= partworth for below $20,000
      set price_med_pw file-read             ;= partworth for $20,001-30,000
      set price_more_pw file-read            ;= partworth for $30,001-40,000
      set price_most_pw file-read            ;= partworth for above $40,001
      set price_pw (list price_low_pw price_med_pw price_more_pw price_most_pw)
      
      set none_pw file-read
      
      set advertising file-read
      set innovativeness file-read
      set knowledge file-read
      set womcount file-read
      
      set monthleft random 6
      set purchasing 0;1 + random 4  ; only purchase regular fule vehicles
      set adoption 0             ; unadopt AFVs
      set nbrs [] 
      
      set readcount readcount + 1                                                      ; increment the read counter to the next line in the spreadsheet
      if     (readcount > sample-count)
      [                                                                                ; if the end of the spreadsheet is reached and there are still more consumer agents to initialize...
        file-close                                                                     ; close the spreadsheet
        set readcount 1                                                                ; reset the read counter
        file-open "NoGroup5NoGroup4_std_1st.txt"                                                            ; re-open the spreadsheet and start at the beginning
      ]
    ]
    file-close                                                                         ; close the spreadsheet
  ]
  
  
  if network? [run social_network]
   
   p "###########################################################################"
   p (word "Consumer Agents: " count consumers  " consumers " )
   ;ask consumers  [p (length [nbrs] of self)]
   
end

to small-world                                                                   ; Small World Network initialization
  let i 0
  let testnbr 0
  
  without-interruption [                                                               ; everything happens sequentially
    ask consumers [                                                                    ; for each consumer...
      set i 0   
      set nbrs turtles-on neighbors4                                  ; neighbors are the set of 8 surrounding neighbors
      set nbrs sort nbrs
      foreach nbrs [                                                                   ; for each networked neighbor of the consumer...
        if far_nbr_prob > (random-float 1) [                                           ; if we have a lucky winner...(make a connection)
          set testnbr one-of consumers                              ; pick a new neighbor
          while [ (testnbr = self)
                  or (member? testnbr nbrs)
                ]                                                                      ; new neighbor can't be a duplicate or self connection
          [ set testnbr one-of consumers ]                          ; try again until the new neighbor is not a dup or self
          set nbrs replace-item i nbrs testnbr                                         ; replace existing Cellular Automata (close) neighbor with new random neighbor
        ]
        set i (i + 1)                                                                  ; refer (index) to the next networked neighbor of the Consumer
      ]

    ]
  ]
end

to scale-free

  let connected_consumer []
  
  ask consumers 
  [
    ifelse length connected_consumer > links_per_consumer
    [ let temp_cc connected_consumer  
      
      repeat links_per_consumer
      [
      let choices_list shuffle temp_cc
      let total_degree sum map [ length [nbrs] of ? ] choices_list
      let n random-float total_degree
      let sellected first choices_list
      let i length [nbrs] of sellected
      while [i < n]
      [set choices_list but-first choices_list
      set sellected first choices_list
      set i i + length [nbrs] of sellected      
      ]
      set nbrs lput sellected nbrs
      set [nbrs] of sellected lput self [nbrs] of sellected
      set temp_cc remove sellected temp_cc
      ]
      set connected_consumer lput self connected_consumer    
    ]
    [ if empty? connected_consumer = False
     [
      foreach connected_consumer
      [ set [nbrs] of ? lput self [nbrs] of ?
        set nbrs lput ? nbrs      
      ]   ]
      set connected_consumer lput self connected_consumer
    
    ] 
  ]


end

to run-market-with [ assortment ]
   ;; after calculating the utility of each product,
   ;; and getting a probability of selection for each product,
   ;; the consumer purchases a product from the assortment
   
   ;; reset the purchase statistics for the assortment
   ask assortment
   [ set units-sold 0
     set profit 0
   ]
      
   ask consumers
   [ ;; using probability values of each design (derived from utility)
     ;; the consumer selects a design
     let selection nobody
     ifelse choice-method = "share of preference"
     [set selection select-on-probability assortment self]
     [set selection select-on-utility assortment self]

     ;; consumer purchases the product
     if selection != nobody
     [consumer.purchase-product selection 
      ;if [fuel] of [module-id] of selection = "Electric"
      ;[show sample_num]
      ;set adoption [module#] of [module-id] of selection
     ]
     ;[set adoption 0]
   ]
   
   ask assortment
   [ calculate-profit-for-product ]
   
end 

to run-real-market-with [ assortment ]
   ;; after calculating the utility of each product,
   ;; and getting a probability of selection for each product,
   ;; the consumer purchases a product from the assortment
   
   ;; reset the purchase statistics for the assortment
   ask assortment
   [ set units-sold 0
     set profit 0
   ]
      
   ask consumers
   [ ;; using probability values of each design (derived from utility)
     ;; the consumer selects a design
     let selection nobody
     ifelse choice-method = "share of preference"
     [set selection select-on-probability assortment self]
     [set selection select-on-utility assortment self]

     ;; consumer purchases the product
     ifelse selection != nobody
     [consumer.purchase-product selection 
      ;if [fuel] of [module-id] of selection = "Electric"
      ;[show sample_num]
      set adoption [module#] of [module-id] of selection
     ]
     [set adoption 0]
     

   ]
   
   ask assortment
   [ calculate-profit-for-product ]
   
end 

;to run-simulated-market-share [ assortment ]  
   
;   ask assortment
 ;  [calculate-utility-for-products
  ;  calculate-probability
;   ]
 ;  set assortment sort assortment
  
;   let total-prob sum map [ [ probability ] of ? ] assortment
 ;  let total-prob2 sum map [ [ probability2 ] of ? ] assortment
   
  ; ask (turtle-set assortment)
   ;[ set units-sold ( market-size * probability  + market-size * probability2 ) / total-prob / 2
   ;  calculate-profit-for-product
     ;set total-profit sum map [ [ profit ] of ? ] assortment
     ;set sum-utility sum map [calculate-utility-for-consumer self ?] sort consumers
   ;]
 
  
   
   
;end

to consumer.purchase-product [ #product-id ]
   ;; having decided to purchase a product, the consumer
   ;; "buys" one of that product
   ;; (rather, each consumer represented by this consumer agent (scale)
   ;; buys one.
   let purch-qty scale
   ask #product-id
   [ set units-sold units-sold + purch-qty
   ]
   ;set product-selection [who] of #product-id
end




;;;  ----------------------------------------
;;;
;;;       DISPLAY SETUP
;;;
;;;  ----------------------------------------

to setup-display

   no-display
   
   let #right x1-list-length 
   let #top   x2-list-length 
   
   set grid-patches patches with [ 0 <= pxcor and pxcor <= x1-index-max 
                                   and
                                   0 <= pycor and pycor <= x2-index-max
                                 ]

   let axis-patches patches with [ ( -1 = pxcor and pycor >= -1 and pycor <= x2-list-length )
                                    or
                                    ( -1 = pycor and pxcor >= -1 and pxcor <= x1-list-length )
                                  ]

   ;; use the quick update hack to update the patches
   ;; initialize the general appearance of patches in the graph
   
   patch.qask patches with [ patch.set-background-color ]
   
   patch.qask grid-patches with [ patch.set-graph-background-pcolor-and-label ]
                                  
   patch.qask axis-patches with [ patch.set-graph-axis-color ]
   
   ;; apply graph labels to specific patches
   ask patch  -2        -1     [ set plabel x2-lookup 0                           ]
   ask patch  -1        -2     [ set plabel x1-lookup 0                           ]
   ask patch  -2         #top  [ set plabel x2-lookup x2-index-max  ]
   ask patch   #right   -2     [ set plabel x1-lookup x1-index-max ]
   
   ask patch  -2                (1 + (#top / 2)) [ set plabel "X2" ]
   ask patch  (#right - (#right / 3)) -2         [ set plabel "X1" ]
   ask patch max-pxcor (max-pycor - 1) [ set plabel "Module Design Parameters and Properties" ]
   
   ask patch  9  8  [set pcolor blue] 
   ask patch 13 8 [set plabel "Gasoline"]
   ask patch  9  6  [set pcolor green]
   ask patch 13 6 [set plabel "Hybrid  "]
   ask patch  9  4  [set pcolor orange]
   ask patch 13  4  [set plabel "Electric  "]
   
   display
end

;; qask is part of the quick patch update hack,
;; in this speed hack, patch commands are run by the patch
;; from within a "WITH" clause, so they run in-order, and
;; without the overhead of pre-shuffling the agents.
to patch.qask [ agentset ] end

to-report patch.set-graph-background-pcolor-and-label 
   ;; used with the quick patch update hack 
   ;; initialize the general appearance of a patch in the graph
   set pcolor white
   set plabel-color black
   set plabel ""
   report false
end
  
to-report patch.set-graph-axis-color
   set pcolor gray
   report false
end

to-report patch.set-background-color
   set plabel-color black
   set pcolor white - .5
   report false
end


to color-patches-by-utility
   ;p "Coloring by Utility (lighter violet = higher utility score)"
   
   let min-v min [ p-utility-g ] of grid-patches
   let max-v max [ p-utility-g ] of grid-patches
   let span-v max-v - min-v
   if span-v = 0 [ set span-v 1 ]
   let min-r span-v * -.1
   let max-r span-v * 1.1
   ask grid-patches [ set pcolor scale-color violet ( p-utility-g - min-v ) min-r max-r ]
end


to patch.all-color-by-module-cost
   p "Coloring by module-cost (lighter orange = lower cost)"
   
   let min-v min [ p-e-cost-g ] of grid-patches
   let max-v max [ p-e-cost-g ] of grid-patches
   let span-v max-v - min-v
   let min-r span-v * -.1
   let max-r span-v * 1.1
   ask grid-patches [ set pcolor scale-color orange ( span-v - (p-e-cost-g - min-v)) min-r max-r ]
end     


to patch.all-color-by-mpg<z1>
   p "Coloring by p-mpg<z1> (lighter green = higher efficiency)"
   
   let min-v min [ p-z1-g ] of grid-patches
   let max-v max [ p-z1-g  ] of grid-patches
   let span-v max-v - min-v
   let min-r span-v * -.1
   let max-r span-v * 1.1
   ask grid-patches [ set pcolor scale-color green (p-z1-g - min-v)  min-r max-r ]
end       

to patch.all-color-by-acc<z2>
   p "Coloring by p-mpg<z1> (lighter magenta = faster 0-60)"
   
   let min-v min [ p-z2-g ] of grid-patches
   let max-v max [ p-z2-g  ] of grid-patches
   let span-v max-v - min-v
   let min-r span-v * -.1
   let max-r span-v * 1.1
   ask grid-patches [ set pcolor scale-color magenta (span-v - (p-z2-g - min-v))  min-r max-r ]
end       

;;;  ----------------------------------------
;;;
;;;             COMPETITION-PHASE
;;;
;;;  ----------------------------------------

to competition-phase

   run-real-market-with ( turtle-set [product-line] of producers )

end

;;;  ----------------------------------------
;;;
;;;               ANALYSIS-PHASE
;;;
;;;  ----------------------------------------

to analysis-phase
   calculate-profit-for-producers 
   calculate-market-share-for-producers
   
   plot.update-plots

   product.products-report-sales-profit
end


to calculate-profit-for-product

     ifelse module-change? = 1
     [set investment-cost penalty * market-size]
     [set investment-cost 0]
     set costs investment-cost + units-sold * unit-mfg-cost + units-sold * unit-regu-cost
     set revenue (units-sold * retail-price)
     set profit revenue - costs
end

to calculate-profit-for-producers
   ask producers
   [ 
     set p-costs sum [ costs ] of product-line
     
     ;let module-line [module#] of first [module-id] of product-line
     ;let past-module-line [module#] of first [module-id] of last-year-product-line
     ;if module-line != past-module-line  ;;if producers change their vehicle type, penalty applied
     ;[set p-costs p-costs + penalty * market-size * products-per-competitor]
     
     set p-revenue sum [ revenue ] of product-line
     set p-profit  sum [ profit  ] of product-line
     ;set t-profit t-profit + (p-profit / 1000000000) ; profit is in billions... 1.0 = 1 billion
     show p-costs
     show p-revenue
     show p-profit
   ]
end

to calculate-market-share-for-producers
   let allproducts turtle-set [product-line] of producers
   let total-units-sold sum [ units-sold ] of allproducts
   ask producers
   [ 
     let myproducts [product-line] of self
     set p-units-sold sum [ units-sold ] of myproducts ;with [ producer-id = myself ]
     if total-units-sold > 0
     [ set market-share p-units-sold / total-units-sold
       set market-share-history fput market-share market-share-history
     ]
   ]
end

to calculate-market-share-for-products
   let allproducts turtle-set [product-line] of producers
   let total-units-sold sum [ units-sold ] of allproducts
   ask products
   [ 
     set market-share units-sold / market-size;total-units-sold
   ]
end
    
   

to product.products-report-sales-profit
   if not output? [ stop ]
   if not output-profit? [stop]

   let producers-by-name producer.all-sorted-by-name
   let #sold 0
   foreach producers-by-name
   [ ask [product-line] of ?
     [set #sold #sold + units-sold
      p (word "Name:" name "  Sales:  "  units-sold "      Profit:   " $$ profit )]
   ]
   
   p (word "None Purchase:" (market-size - #sold) )  

end



;;;  ----------------------------------------
;;;
;;;            PRODUCTION-PHASE
;;;
;;;  ----------------------------------------

to production-phase
   ask producers
   [ 
     ;set all-product-line ( turtle-set sentence sort product-line sort all-product-line )
    
     set all-product-line ( turtle-set all-product-line product-line )
     
     if any? last-year-product-line
     [  ask last-year-product-line [ turtle.hide ]
        set last-year-product-line no-turtles
     ]
     if any? product-line
     [ ask product-line [ turtle.hide ]
       set last-year-product-line product-line
       set product-line no-turtles
     ]
   ]
   
   ;; producers create new products for the production year, using some strategy
   ask producers
   [ run strategy ];; run the competition strategy selection made for this producer
   
   p (word "############# The " month "th iteration################"  )
   let producers-by-name producer.all-sorted-by-name
   foreach producers-by-name
   [
     ask [product-line] of ?
     [ product.display 
     product.output-product-info 
     set pick pick + 1 
     ]
   ]
   
   ;ask ( turtle-set [product-line] of producers )
   ;[ product.display 
   ;  product.output-product-info 
   ;  set pick pick + 1 ] 
   
   ;ask patch 8 11 [ set pcolor red ]
   
   global:update-product-list
end

;;;  ----------------------------------------
;;;
;;;               SETUP moduleS
;;;
;;;  ----------------------------------------

to setup-modules
  ;; this routine loads the module data and creates the module designs that can be used in products
  ;; the module defines a set of parameters available to the product
  ;; (eg, the specific acc and mpg the module design can provide 
  ;; given x1 and x2 (scale and drive ratio) applied to the product design
  
  ;; module design data is also loaded into the patches

  ;; first make sure there are no modules
  ask modules [ die ]

  ;; set global module parameters tables
  
  set x1-list-length   7   ;(comppression ratio)
  set x1-index-max     x1-list-length - 1
  set x1-index-min     0
  set x1-index-span    x1-index-max - x1-index-min
  set x1-min           5
  let x1-resolution    2
  set x1-max x1-min + x1-list-length * x1-resolution
  
  set x2-list-length   9    ;(module power)
  set x2-index-max     x2-list-length - 1
  set x2-index-min     0
  set x2-index-span    x2-index-max - x2-index-min
  set x2-min           100
  let x2-resolution    50
  set x2-max x2-min + x2-list-length * x2-resolution
  
  
  set markup%-span markup%-max - markup%-min
  
  ;; generate x1-list (x1 values) from min-value and resolution
  set  x1-list  n-values x1-list-length [ precision (x1-min + x1-resolution * ?) 5 ] ;; ? is the index
  ;; result, e.g.: [  9 9.5 10 ... 12  ]
  
  ;; generate drive-ration-list (x2 values) from min-value and resolution
  set  x2-list  n-values x2-list-length [ precision (x2-min + x2-resolution * ? ) 2 ] ;; ? is the index
  ;  [  100 150 200...500 ]
  
  ;set  module-power-list map [ ? * 88 ] x1-list ;; shouldn't this be different for the two modules?
    
  (foreach
  [ ;; module details
    [ "Gasoline" ;; fuel type
      "Sedan"  ;; car type
      1      ;; module number
      102    ;; power in kW
      670.51    ;; beta"4"
      0.0063    ;; beta"5"
      "module.cost-function-SI102" ;; unit-design-cost-function
      ;; mpg table (z1)
      [
        [26.13617358   27.61116464   28.05301679   29.46173002   30.83730435   31.17973976   32.48903627 ]
        [25.27405684   26.69272249   27.08217891   29.44242609   30.77346405   31.07529277   31.34791226 ]
        [24.26632932   25.64548362   26.5981853    28.32443436   29.62423079   30.89757459   31.14446577 ]
        [23.81515472   24.16575044   25.49188599   26.79356138   28.0707766    29.32353166   30.55182655 ]
        [23.18692274   24.01531527   25.32079669   25.60336701   26.86302622   28.09977432   29.31361132 ]
        [22.76648972   23.07676846   24.36539985   24.63238389   25.87772057   26.1014099    28.30345187 ]
        [21.97649973   22.27123176   23.14540109   23.79900773   24.33205166   25.24453289   27.43645142 ]
        [21.26505287   21.04578389   21.80692902   22.24848827   23.27046163   24.47284911   26.6556507  ]
        [20.59501709   20.16256205   21.11144108   21.84165418   22.55320136   23.74608261   25.92029793 ]
      ]
      ;; cost table (z2)
      [
        [14136.52536   15136.52532   16136.52532   17136.52532   18136.52532   19136.52532   20136.52532 ]
        [14980.11325   15980.11325   16980.11325   17980.11325   18980.11325   19980.11325   20980.11325 ]
        [15694.35877   16694.35877   17694.35877   18694.35877   19694.35877   20694.35877   21694.35877 ]
        [16328.53167   17328.53167   18328.53167   19328.53167   20328.53167   21328.53167   22328.53167 ]
        [16907.53177   17907.53177   18907.53177   19907.53177   20907.53177   21907.53177   22907.53177 ]
        [17445.9199    18445.9199    19445.9199    20445.9199    21445.9199    22445.9199    23445.9199  ]
        [17953.03831   18953.03831   19953.03831   20953.03831   21953.03831   22953.03831   23953.03831 ]
        [18435.27867   19435.27867   20435.27867   21435.27867   22435.27867   23435.27867   24435.27867 ]
        [18897.2252    19897.2252    20897.2252    21897.2252    22897.2252    23897.2252    24897.2252  ]
      ]
    ] ;; end Gasoline Sedan
    [ "Gasoline" ;; fuel type
      "SUV"  ;; car type
      2      ;; fuel and car number
      102    ;; power in kW
      670.51    ;; beta"4"
      0.0063    ;; beta"5"
      "module.cost-function-SI102" ;; unit-design-cost-function
      ;; mpg table (z1)
      [
        [22.94129426  23.35341126  23.73677592  24.09138822  24.41724818  24.71435579  24.98271104]
        [20.91120141  21.28336693  21.62956741  21.94980286  22.24407327  22.51237865  22.75471898]
        [19.33208356  19.67317262  19.99046477  20.28396001  20.55365833  20.79955975  21.02166425]
        [18.17145456  18.48970287  18.7857478   19.05958937  19.31122756  19.54066238  19.74789384]
        [17.23376865  17.53356364  17.8124427   18.07040583  18.30745303  18.5235843   18.71879964]
        [16.44716924  16.73148424  16.99596331  17.24060645  17.46541366  17.67038494  17.85552029]
        [15.7582741   16.0290319   16.28089962  16.51387726  16.72796482  16.9231623   17.0994697]
        [15.13512705  15.39362155  15.63408154  15.85650703  16.06089802  16.24725452  16.41557651]
        [14.54406597  14.7909286   15.02056825  15.23298493  15.42817863  15.60614936  15.76689712]

      ]
      ;; cost table (z2)
      [
        [20979.67226   21979.67226   22979.67226   23979.67226   24979.67226   25979.67226   26979.67226 ]
        [21024.35828   22024.35828   23024.35828   24024.35828   25024.35828   26024.35828   27024.35828 ]
        [21062.02937   22062.02937   23062.02937   24062.02937   25062.02937   26062.02937   27062.02937 ]
        [21095.21752   22095.21752   23095.21752   24095.21752   25095.21752   26095.21752   27095.21752 ]
        [21125.2213    22125.2213    23125.2213    24125.2213    25125.2213    26125.2213    27125.2213  ]
        [21152.81212   22152.81212   23152.81212   24152.81212   25152.81212   26152.81212   27152.81212 ]
        [21178.4926    22178.4926    23178.4926    24178.4926    25178.4926    26178.4926    27178.4926  ]
        [21202.61186   22202.61186   23202.61186   24202.61186   25202.61186   26202.61186   27202.61186 ]
        [21225.42408   22225.42408   23225.42408   24225.42408   25225.42408   26225.42408   27225.42408 ]

      ]
    ] ;; end Gasoline SUV
    
    [ "Hybrid" ;; fuel type
      "Sedan"  ;; car type
      3      ;; fuel and car number
      102    ;; power in kW
      670.51    ;; beta"4"
      0.0063    ;; beta"5"
      "module.cost-function-SI102" ;; unit-design-cost-function
      ;; mpg table (z1)
      [  
        [36.13617358   37.61116464   38.05301679   39.46173002   40.83730435   41.17973976   42.48903627 ]
        [35.27405684   36.69272249   37.08217891   39.44242609   40.77346405   41.07529277   41.34791226 ]
        [34.26632932   35.64548362   36.5981853    38.32443436   39.62423079   40.89757459   41.14446577 ]
        [33.81515472   34.16575044   35.49188599   36.79356138   38.0707766    39.32353166   40.55182655 ]
        [33.18692274   34.01531527   35.32079669   35.60336701   36.86302622   38.09977432   39.31361132 ]
        [32.76648972   33.07676846   34.36539985   34.63238389   35.87772057   36.1014099    38.30345187 ]
        [31.97649973   32.27123176   33.14540109   33.79900773   34.33205166   35.24453289   37.43645142 ]
        [31.26505287   31.04578389   31.80692902   32.24848827   33.27046163   34.47284911   36.6556507  ]
        [30.59501709   30.16256205   31.11144108   31.84165418   32.55320136   33.74608261   35.92029793 ]
      ]
      ;; cost table (z2)
      [
        [20136.52536   21136.52532   22136.52532   23136.52532   24136.52532   25136.52532   26136.52532 ]
        [21980.11325   22980.11325   23980.11325   24980.11325   25980.11325   26980.11325   27980.11325 ]
        [22694.35877   23694.35877   24694.35877   25694.35877   26694.35877   27694.35877   28694.35877 ]
        [23328.53167   24328.53167   25328.53167   26328.53167   27328.53167   28328.53167   29328.53167 ]
        [24907.53177   25907.53177   26907.53177   27907.53177   28907.53177   29907.53177   30907.53177 ]
        [26445.9199    27445.9199    28445.9199    29445.9199    30445.9199    31445.9199    32445.9199  ]
        [27953.03831   28953.03831   29953.03831   30953.03831   31953.03831   32953.03831   33953.03831 ]
        [29435.27867   30435.27867   31435.27867   32435.27867   33435.27867   34435.27867   35435.27867 ]
        [30897.2252    31897.2252    32897.2252    33897.2252    34897.2252    35897.2252    36897.2252  ]
      ]
    ] ;; end Hybrid Sedan
    [ "Hybrid" ;; fuel type
      "SUV"  ;; car type
      4      ;; fuel and car number
      102    ;; power in kW
      670.51    ;; beta"4"
      0.0063    ;; beta"5"
      "module.cost-function-SI102" ;; unit-design-cost-function
      ;; mpg table (z1)
      [  
        [25.94129426   26.35341126   26.73677592   27.09138822   27.41724818   27.71435579   27.98271104 ]
        [23.91120141   24.28336693   24.62956741   24.94980286   25.24407327   25.51237865   25.75471898 ]
        [22.33208356   22.67317262   22.99046477   23.28396001   23.55365833   23.79955975   24.02166425 ]
        [21.17145456   21.48970287   21.7857478    22.05958937   22.31122756   22.54066238   22.74789384 ]
        [20.23376865   20.53356364   20.8124427    21.07040583   21.30745303   21.5235843    21.71879964 ]
        [19.44716924   19.73148424   19.99596331   20.24060645   20.46541366   20.67038494   20.85552029 ] 
        [18.7582741    19.0290319    19.28089962   19.51387726   19.72796482   19.9231623    20.0994697  ]
        [18.13512705   18.39362155   18.63408154   18.85650703   19.06089802   19.24725452   19.41557651 ] 
        [17.54406597   17.7909286    18.02056825   18.23298493   18.42817863   18.60614936   18.76689712 ]
      ]
      ;; cost table (z2)
      [
      
        [24774.68907   25774.68907   26774.68907   27774.68907   28774.68907   29774.68907   30774.68907 ]
        [25662.47658   26662.47658   27662.47658   28662.47658   29662.47658   30662.47658   31662.47658 ]
        [26410.93596   27410.93596   28410.93596   29410.93596   30410.93596   31410.93596   32410.93596 ]
        [28073.35202   29073.35202   30073.35202   31073.35202   32073.35202   33073.35202   34073.35202 ]
        [29676.42243   30676.42243   31676.42243   32676.42243   33676.42243   34676.42243   35676.42243 ]
        [31235.70063   32235.70063   33235.70063   34235.70063   35235.70063   36235.70063   37235.70063 ]
        [33761.14776   34761.14776   35761.14776   36761.14776   37761.14776   38761.14776   39761.14776 ]
        [35259.5745    36259.5745    37259.5745    38259.5745    39259.5745    40259.5745    41259.5745  ]
        [36735.86742   37735.86742   38735.86742   39735.86742   40735.86742   41735.86742   42735.86742 ]

      ]
    ] ;; end Hybrid SUV
    [ "Electric" ;; fuel type
      "Sedan"  ;; car type
      5      ;; fuel and car number
      102    ;; power in kW
      670.51    ;; beta"4"
      0.0063    ;; beta"5"
      "module.cost-function-SI102" ;; unit-design-cost-function
      ;; mpg table (z1)
      [  
        [86.724634    96.724634    106.724634    116.724634    126.724634    136.724634    146.724634  ]
        [85.9871404   95.9871404   105.9871404   115.9871404   125.9871404   135.9871404   145.9871404 ]
        [85.4166899   95.4166899   105.4166899   115.4166899   125.4166899   135.4166899   145.4166899 ]
        [82.9591282   92.9591282   102.9591282   112.9591282   122.9591282   132.9591282   142.9591282 ]
        [80.7595025   90.7595025   100.7595025   110.7595025   120.7595025   130.7595025   140.7595025 ]
        [79.7513407   89.7513407    99.7513407   109.7513407   119.7513407   129.7513407   139.7513407 ]
        [75.9926116   85.9926116    95.9926116   105.9926116   115.9926116   125.9926116   135.9926116 ]
        [71.7841688   81.7841688    91.7841688   101.7841688   111.7841688   121.7841688   131.7841688 ]
        [67.17192231  77.17192231   87.1719223   97.17192231   107.1719223   117.1719223   127.1719223 ]
      ]
      ;; cost table (z2)
      [
        [25064.70188   25564.70188   26564.70188   27564.70188   29064.70188   30564.70188   32064.70188 ]
        [26770.6704    27270.6704    28270.6704    29270.6704    30770.6704    32270.6704    34770.6704  ]
        [28765.6951    29265.6951    30265.6951    31265.6951    32765.6951    34265.6951    36765.6951  ]
        [30953.84672   31453.84672   32453.84672   33453.84672   34953.84672   36453.84672   38953.84672 ]
        [33328.06557   33828.06557   34828.06557   35828.06557   36328.06557   37828.06557   39328.06557 ]
        [35908.22126   36408.22126   37408.22126   38408.22126   39908.22126   41408.22126   43908.22126 ]
        [38728.95784   39228.95784   40228.95784   41228.95784   42728.95784   44228.95784   46728.95784 ]
        [41838.47008   42338.47008   43338.47008   44338.47008   45838.47008   47338.47008   49838.47008 ]
        [45301.79761   45801.79761   46801.79761   47801.79761   49301.79761   50801.79761   52301.79761 ]

      ]
    ] ;; end Electric Sedan
    [ "Electric" ;; fuel type
      "SUV"  ;; car type
      6      ;; fuel and car number
      102    ;; power in kW
      670.51    ;; beta"4"
      0.0063    ;; beta"5"
      "module.cost-function-SI102" ;; unit-design-cost-function
      ;; mpg table (z1)
      [  
        [62.31923593   72.31923593   82.31923593   92.31923593   102.31923593   112.31923593   122.31923593 ]
        [61.65529367   71.65529367   81.65529367   91.65529367   101.65529367   111.65529367   121.65529367 ]
        [60.99584388   70.99584388   80.99584388   90.99584388   100.99584388   110.99584388   120.99584388 ]
        [59.91931495   69.91931495   79.91931495   89.91931495   99.91931495   109.91931495   119.91931495 ]
        [57.52766276   67.52766276   77.52766276   87.52766276   97.52766276   107.52766276   117.52766276 ]
        [55.20761951   65.20761951   75.20761951   85.20761951   95.20761951   105.20761951   115.20761951 ]
        [54.69482502   64.69482502   74.69482502   84.69482502   94.69482502   104.69482502   114.69482502 ]
        [51.53860955   61.53860955   71.53860955   81.53860955   91.53860955   101.53860955   111.53860955 ]
        [48.1259758    58.1259758    68.1259758    78.1259758    88.1259758    98.1259758    108.1259758  ]
      ]
      ;; cost table (z2)
      [
      
        [31376.25195   31876.25195   32876.25195   33876.25195   35376.25195   36876.25195   38876.25195 ]
        [32906.80422   33406.80422   34406.80422   35406.80422   36906.80422   38406.80422   40406.80422 ]
        [34870.48824   34370.48824   35370.48824   36370.48824   37870.48824   39370.48824   41370.48824 ]
        [37062.43216   37562.43216   38562.43216   39562.43216   41562.43216   43062.43216   45062.43216 ]
        [39440.0936    39940.0936    40440.0936    41440.0936    42940.0936    44440.0936    46440.0936  ]
        [42003.6508    42503.6508    43503.6508    44503.6508    46003.6508    47503.6508    49503.6508  ]
        [44771.12299   45271.12299   46271.12299   47271.12299   48771.12299   50271.12299   52271.12299 ]
        [47772.11748   48272.11748   49272.11748   50272.11748   51772.11748   53272.11748   55272.11748 ]
        [51047.34246   51547.34246   52547.34246   53547.34246   55047.34246   56547.34246   58547.34246 ]

      ]
    ] ;; end Electric SUV
    
  ] ;; end module and car type details table
  
  [ 
    
    ;; create an module
    create-modules 1
    [ set fuel item 0 ?
      set cartype item 1 ?
      set module# item 2 ?
      set power item 3 ?
      set cost-parameter-a item 4 ?
      set cost-parameter-b item 5 ?
      set cost-function item 6 ?
      set z1-table item 7 ? 
      set z2-table item 8 ?
      
      set cost-function (word cost-function "" )
      
      set e-cost-table
          map
            [ #run-result (word cost-function " " ?) ]
            x1-list

      ;; display stuff
      turtle.hide
    ]
  ])

  ;; store module table values in patches

  
  set grid-patches patches with [ 0 <= pxcor and pxcor <= x1-index-max 
                                  and
                                  0 <= pycor and pycor <= x2-index-max
                                ]

  ;; store modules temporarily in these variables for easy access
  ;; this will have to be refactored if there are ever more than 2 module designs
  let gas-module one-of modules with [ fuel = "Gasoline" ]
  let hybrid-module one-of modules with [ fuel = "Hybrid" ]
  let electric-module one-of modules with [fuel = "Electric" ]
  

  ;; get patches that lie inside the tables to fill with data from the tables
  ask grid-patches 
  [ 
    set p-x1-index pxcor
    set p-x2-index pycor
    let #x1i pxcor ;; i for index, x1i is the column 
    let #x2i pycor ;; i for index, x2i is the row
    set p-x1 item #x1i x1-list
    set p-x2 item #x2i x2-list
    ;set p-z1-g [ cell #x2i #x1i z1-table ] of gas-module
   ; set p-z2-g [ cell #x2i #x1i z2-table ] of gas-module
   ; set p-z1-d [ cell #x2i #x1i z1-table ] of diesel-module
   ; set p-z2-d [ cell #x2i #x1i z2-table ] of diesel-module
    let #x1 p-x1
    ;set p-e-cost-g precision ( [ #run-result (word cost-function  " " #x1) ] of gas-module )   2 
    ;set p-e-cost-d precision ( [ #run-result (word cost-function " " #x1) ] of diesel-module ) 2
   ; set p-e-price-g precision ( unit-mfg-base-cost + p-e-cost-g ) 2 ;; the calculated gas module vehicle base price (no markup)
   ; set p-e-price-d precision ( unit-mfg-base-cost + p-e-cost-d ) 2 ;; the calculated desiel module vehicle base price (no markup)
    ; set p-b-utility-g consumer.utility-perception 0 p-z1-g p-z2-g ;; the calculated base gase module utility (does not include the retial price term, only z1, z2)
    ; set p-b-utility-d consumer.utility-perception 0 p-z1-d p-z2-d ;; the calculated base desiel module utility (does not include the retial price term, only z1, z2)
    ; set p-utility-g   consumer.utility-perception p-e-price-g p-z1-g p-z2-g ;; the calculated utility perception (including a retail price term) for the gas module
    ; set p-utility-d   consumer.utility-perception p-e-price-d p-z1-d p-z2-d ;; the calculated utility perception (including a retail price term) for the desiel module
    ;; use PATCH.UTILITY-PERCEPTION-UPDATE #markup% to update p-utility-* with utility value for a specific price markup%
    set payoff 0
  ]
  
  ;set min-module-cost min [ p-e-cost-g  ] of grid-patches
  set min-module-cost min [ min (list p-e-cost-g p-e-cost-d) ] of grid-patches
  ;set max-module-cost max [ p-e-cost-g  ] of grid-patches
  set max-module-cost max [ max (list p-e-cost-g p-e-cost-d) ] of grid-patches

  
end

 

to-report #run-result [ input ]
   report runresult input
end

to-report cell [ #row #col #table ]
   ;; get the contents of the cell at the given row and column of the table
   report ( item #col ( item #row #table ) )
end
to-report test-function [ number ]
   report cost-parameter-a * exp ( cost-parameter-b * power * number )
   ;; report cost-parameter-a + cost-parameter-b
end
   

to-report module.cost-function-SI102 [ #x1 ]
   report cost-parameter-a * exp ( cost-parameter-b * power * #x1 )
end

to-report module.cost-function-CI88 [ #x1 ]
   report cost-parameter-a * power * #x1 + cost-parameter-b
end

to-report x1-lookup [ #index ] ;; index, not value
   report item #index x1-list ;; reports the value
end

to-report x2-lookup [ #index ]  ;; index, not value
   report item #index x2-list ;; reports the value
end  
    

to-report z1-lookup [ #x1-index #x2-index #module ]
   ;; looks up mpg<z1> value from the  z1-table of the given-module
   report ( cell #x2-index #x1-index [ z1-table] of #module )
end   

to-report z2-lookup [ #x1-index #x2-index #module ]
   ;; look up acc<z2> value from the z2-table of the given module
   report ( cell #x2-index #x1-index  [z2-table] of #module )
end


;;;  ----------------------------------------
;;;
;;;             HELPER PROCEDURES
;;;
;;;  ----------------------------------------

to p [ string ] 
   ;; text output helper 
   ;; shortcut for output-print
   output-print string
end
   
to-report c [ num1 num2 ] 
   ;; text output formatting helper
   ;; reports string that is the two numbers seperated by a comma
   report (word num1 "," num2)
end
      
to turtle.hide ; Procedure: set display properties to hide turtlea
   ;;  setxy 0 0 ; send turtle to origin
   ;;  set color black ; make turtle black
   ;;  set shape "blank" ; make turtle have no shape
   hide-turtle ; set turtle to hidden? = true
end

to patches.update-pick-graph   ; Procedure: update the pick frequency graph
   if ( ticks mod 10 = 0 )     ; do this only every 10 ticks
   [ let non-zero-patches grid-patches with [ pick > 0 ] ; get the set of grid patches with a pick value greater than zero
     if any? non-zero-patches                         ; if there are any such grid patches...
     [
       let max-pick max [ pick ] of grid-patches    ; calculate the maximum value of pick from the patches
       ask non-zero-patches                         ; command the set of non-zero patches
       [ set pcolor (blue + 4 - .5 * ( scale-color gray pick 0 max-pick )) ;    to turn a shade of blue corresponding the the value of pick
       ]
     ]
   ]  
end

to-report commas [ number ] ; Procedure: format a number with commas and 2 decimal places, and some left-side padding.
   ;; test output format helper
   ;; formats a number as a comma-inserted value, with 2 decimal places, taking up 18 characters
   ;; 
   ;; 1024  ==>  "          1,024.00 "
   ;; -123.4 ==> "           (123.40)"
   let d floor abs number
   let s ""
   let i 1
   while [ d > 0 ]
   [ set s (word (d mod 10) s)
     set d floor ( d / 10 )
     if i > 0 and i mod 3 = 0 and d > 0
     [ set s (word "," s) ]
     set i i + 1
   ]
   let decimals reverse (substring reverse (word "00" (floor (100 * (number - floor number)))) 0 2)
   let n 15 - length s
   let pp substring "                    " 0 n
   let p1 "(" let p2 ")"
   if number >= 0 [ set p1 " " set p2 " " ]   
   report (word pp p1 s "." decimals p2 )
end

to-report $$ [ number ] ; procedure: format a number with dollar sign, commas, and 2 decimal spaces, and some left-side padding.
   ;; text output format helper
   ;; formats a number as a comma-inserted value with a dollar sign, taking up 20 spaces:
   ;; "1024"  ==>  "$       1,024.00 " 
   report (word "$" commas number )
end
 
;;; ---------------------------------
;;;
;;;  UPDATE PLOTS
;;;
;;; ---------------------------------

to plot.update-plots
   
   let producers-by-name producer.all-sorted-by-name
   let modules-by-# modules.all-sorted-by-#
   
   set-current-plot "Profit"
   foreach producers-by-name
   [ ask ?
     [ set-current-plot-pen name
       plot p-profit
     ]
   ]
   set-current-plot-pen "zero"
   plot 0

   set-current-plot "Markup"
   foreach producers-by-name
   [ ask ?
     [ ifelse any? product-line
       [ set-current-plot-pen name
         plot mean [ markup% ] of product-line
       ] 
       [ plot 0
       ]
     ]
   ]


  set-current-plot "Sales"
   foreach producers-by-name 
   [ ask ?
     [ ifelse any? product-line
       [ set-current-plot-pen name
         plot mean [ units-sold ] of product-line
       ] 
       [ plot 0
       ]
     ]
   ]
  
  set-current-plot "Sales by Module"
  foreach modules-by-#
  [ ask ?
    [ set-current-plot-pen word fuel cartype
      let allproducts turtle-set [product-line] of producers
      plot sum [units-sold] of allproducts with [module-id = ?]    
    ]
  ]
    
   
  set-current-plot "Market Share"
   foreach producers-by-name
   [ ask ?
     [ ifelse any? product-line
       [ set-current-plot-pen name
         plot market-share
       ] 
       [ plot 0
       ]
     ]
   ]
   set-current-plot-pen "even"
   plot (1 / competitors)  

end

to-report producer.all-sorted-by-name
   report sort-by [ [ name ] of ?1 <= [ name ] of ?2] producers
end

to-report modules.all-sorted-by-#
   report sort-by [ [ module# ] of ?1 <= [ module# ] of ?2] modules
end
  
  
to-report choose-next-design [ using-strategy ]
   report run-result using-strategy
end

to-report copy-product [ prototype number-of-copies ]
   ;; report a list containing sum number of copies of the product
   let new-pool []
   ask prototype
   [ hatch number-of-copies
     [ set new-pool fput self new-pool
       turtle.hide
     ]
   ]
   report new-pool
end

to drunken-ceo
   
   if any? product-line [ ask one-of product-line [ die ] ]
   repeat products-per-competitor
   [
   let new-product-params (list random 2 random-x1 random-x2 random-markup)
   ;; create a new product using the reported random parameters
   ;; assign that product a model name 
   ;; add to new product line
   ask new-product
   [ 
     turtle.hide
     apply-product-parameters new-product-params 
     increment-model-number-and-set-model-name
     add-product-to-product-line
   ]
   ]
end


to genetic-algorithm
   ;; get the products from the competition
   let competition-set []
   ask producers with [ self != [producer-id] of myself]
   [  
     ifelse any? [product-line] of self
     [set competition-set (turtle-set competition-set [product-line] of self ) ]
     [set competition-set (turtle-set competition-set [last-year-product-line] of self)]
   ]
   
   ;let competition-set (turtle-set [ last-year-product-line ] of producers with [ self != [ producer-id ] of myself ] )
   ;; run product trials using a genetic algorithm to "evolve" a superior profit-making product 
   let new-products-selected genetic-selection-strategy
       (one-of last-year-product-line) ;; the initial product  to use
       competition-set ;; the z2products to compete against
       10 ;; pool size
       0.8 ; cross-over prob
       0.1 ; mutation-prob
       200 ; generations
   
   ;; create a new product using the reported "evolved" parameters
   ;; assign that product a model name 
   ;; add to new product line
   foreach sort new-products-selected
   [
     ask new-product
     [ 
       turtle.hide
       set module-id [module-id] of ? ;one-of modules with [ fuel = "gas" ]
       set x1-index [x1-index] of ?
       set x2-index [x2-index] of ?
       set markup% [markup%] of ?
       calculate-secondary-design-values
       ;apply-product-parameters 
       increment-model-number-and-set-model-name
       add-product-to-product-line
     ]
   ]
end

    
   
to-report genetic-selection-strategy  
[ 
  prototype ;; a product to use as the prototype for the gene-pool
  competition-set ;; a list of the competition agents
  pool-size ;; the number of members of the gene pool (trial members)
  crossover-prob ;; the probability that a  worst member will intermingle genes with the selected members
  mutation-prob ;; the probability that the worst member will mutate
  generations 
]
   ;; run by a producer
   ;; producer is "myself" here
   ;; generate a pool of product using the given genes and the competition

   let population []
   ifelse count all-product-line >= pool-size
   [ ask all-product-line
     [ run-market-with (turtle-set competition-set self )
     ]   
     set population sort max-n-of  pool-size all-product-line [ profit ]
   ]
   [
     set population sentence sort all-product-line copy-product prototype ( pool-size - count all-product-line )
     foreach population
     [ run-market-with ( turtle-set competition-set ? ) 
     ]
   ]

   
   
   repeat generations
   [ 
     ;; find the worst performing product
     let worst-member min-one-of (turtle-set population) [ profit ]
     
        ;; make a copy of population list
        let pop-list population
        ;; select one member
        let selected1 select-on-profit pop-list
        ;; remove that member from the list
        set pop-list remove selected1 pop-list
        ;; select another member
        let selected2 select-on-profit pop-list
        ;;delete the pop-list
        set pop-list []
         
     ;; breed selected members
     
     ;; make offspring product that's a copy of one of the selected members
     let offspring one-of copy-product selected1 1
      
     ;; for each trait, see if the trait crosses over from the other selected member
     if ( crossover-prob > random-float 1.0 ) 
     [
       let g random-float 1.0
       ifelse g < 4 / 16
       [ let up max [x1-index] of ( turtle-set selected1 selected2)
        let down min [x1-index] of ( turtle-set selected1 selected2)
        ask offspring [set x1-index down + random (up - down + 1) ]
       ]
       ;[ let t [ x1-index ] of selected2 ask offspring [ set x1-index t ] ]
       [
         ifelse g >= 4 / 16 and g <= 9 / 16
         [ let up max [x2-index] of ( turtle-set selected1 selected2)
           let down min [x2-index] of ( turtle-set selected1 selected2)
           ask offspring [set x2-index down + random (up - down + 1) ]
         ]
         [ 
           ifelse g >= 9 / 16 and g <= 15 / 16
           [ let up max [markup%] of ( turtle-set selected1 selected2)
             let down min [markup%] of ( turtle-set selected1 selected2)
             ask offspring [set markup% down + random-float (up - down) ]
           ]
           [ let module-select [module#] of [module-id] of selected1 + [module#] of [module-id] of selected2
             ask offspring
             [ set module-id one-of modules with [module# = round (module-select / 2)]
             ]
           ]
         ]
       ]
       ask offspring [ calculate-secondary-design-values 
                     run-market-with (turtle-set competition-set offspring)
                   ]
     ]
     
     ;; if the proft of the offspring is better than the profit of the original
     ;; "worst" member, then remove the worst member and add the offspring to the pool
     
     ifelse [ profit ] of offspring > [ profit ] of worst-member
     [ ;; offspring is superior, remove worst member,
       ;; replace with offspring
       ask worst-member [set x1-index [x1-index] of offspring
                         set x2-index [x2-index] of offspring
                         set markup% [markup%] of offspring
                         set module-id [module-id] of offspring
                         calculate-secondary-design-values
                         run-market-with (turtle-set competition-set self)
                        ]
        ;set worst-member first copy-product offspring 1
       ask offspring [ die ]
     ]
     [ ask offspring [ die ]
     ]
     
     
     ;; mutate all the members
     ask (turtle-set population)
     [
          ;; for each trait, see if the trait mutates
       if ( random-float 1.0 < mutation-prob) 
       [
         let g random-float 1.0
         ifelse g < 4 / 16
         [  change-x1-index +/- random 3 ]
         [  ifelse g >= 4 / 16 and g <= 9 / 16
            [  change-x2-index +/- random 3 ] 
            [ifelse g >= 9 / 16 and g <= 15 / 16
             [ change-markup% +/- random-float 1 ] 
             [ let module#self [module#] of [module-id] of self
               set module-id one-of modules with [module# != module#self ] ]
            ]
         ]
         calculate-secondary-design-values
         run-market-with (turtle-set competition-set self)
       ]
     ]
     
    
   
   ] ;; and so on for the requested number of generations
   
  
   ;; select the best performing member
   let selected max-n-of  products-per-competitor (turtle-set population) [ profit ]
      
  
   ;; report select product agentset
   report selected 
end

to simulated-annealing
   ;; get the products from the competition
   let competition-set []
   ask producers with [ self != [producer-id] of myself]
   [  
     ifelse any? [product-line] of self
     [set competition-set (turtle-set competition-set [product-line] of self ) ]
     [set competition-set (turtle-set competition-set [last-year-product-line] of self)]
   ]
   
   ;let competition-set (turtle-set [ last-year-product-line ] of producers with [ self != [ producer-id ] of myself ] )
   ;; run product trials using simulated annealing to "forge" a superior profit-making product 
   let new-products-selected simulated-annealing-strategy
       (one-of last-year-product-line) ;; the initial product  to use
       competition-set ;; the products to compete against
       100 ; initial "temperature" (0.0 ... 1.0)
       0.01 ; final "temperature"  (0.0 ... 1.0)
       100  ; Maxiteration
       
   ;; create a new product using the reported "evolved" parameters
   ;; assign that product a model name 
   ;; add to new product line
   foreach sort new-products-selected
   [
     ask new-product
     [ 
       turtle.hide
       set module-id [module-id] of ? ;one-of modules with [ fuel = "gas" ]
       set x1-index [x1-index] of ?
       set x2-index [x2-index] of ?
       set markup% [markup%] of ?
       set module-change? [module-change?] of ?
       calculate-secondary-design-values
       ;apply-product-parameters 
       increment-model-number-and-set-model-name
       add-product-to-product-line
     ]
   ]
   
end

to-report simulated-annealing-strategy  
[ prototype ;; a product to use as the prototype for the gene-pool
  competition-set ;; a list of the competition agents
  init-temp ; initial "temperature" 
  final-temp ; final "temperature" 
  MaxIteration ; temperature steps between high and low temperature
]
   ;; run by a producer
   ;; producer is "myself" here
   ;; generate a test prototype
   ;ask (turtle-set curr-product best-product )
   run-market-with (turtle-set competition-set prototype )
   
   let curr-product first copy-product prototype 1
   let best-product first copy-product prototype 1
   let trial-product first copy-product prototype 1
   let curr-module# [module#] of [module-id] of curr-product
   
   
   ;; repeat the annealing process
   let n 0
   set init-temp 1 * [profit] of curr-product + 1
   
   let temperature init-temp
   
    ;let cooling-temp (init-temp - final-temp ) / tweens
   while [ n < MaxIteration ];repeat tweens
   [ 
       set temperature init-temp * ( ( final-temp / init-temp ) ^ ( n / MaxIteration ) )
       
       ask trial-product
       [
         change-x1-index +/- random 2  
         change-x2-index +/- random 2
         change-markup% +/- random-float 10
         
         ;let temp-module-id module-id
         if change-car? 
         [set module-id one-of modules]
         ifelse [module#] of module-id != curr-module#
         [set module-change? 1]
         [set module-change? 0]
         calculate-secondary-design-values
       ]
       run-market-with (turtle-set competition-set trial-product )
       
       
       let u_trial [profit] of trial-product
       let u_curr [profit] of curr-product
      
       let p_accept 0
       ifelse u_trial >= u_curr
       [set p_accept 1]
       [set p_accept exp ( ( u_trial - u_curr ) * 100  / temperature ) ]
        
       ifelse random-float 1 <= p_accept
       [  ask curr-product [die]
          set curr-product first copy-product trial-product 1
          ;if u_trial > [profit] of best-product
          ;[ ask best-product [die]
            set best-product (turtle-set best-product first copy-product curr-product 1)
            
          ;]
       ]
       [
         ask trial-product [die]
         set trial-product first copy-product curr-product 1
       ]
       
       set n n + 1
       
       show n
     ]
   set best-product (turtle-set best-product)
   ;; finally
   let selected max-n-of products-per-competitor best-product [profit]
   set selected copy-product selected 1
   ask (turtle-set trial-product curr-product best-product) [die]
   
   ;; record parameters of final trial member
   ;let ga-x1 [ x1-index ] of selected
   ;let ga-x2 [ x2-index ] of selected
   ;let ga-markup [ markup% ] of selected
   
   ;; delete trial products
   ;ask trial-product [ die ]
   
   ;; report parameters of winning trial product
   report selected  ;( list ga-x1 ga-x2 ga-markup )
end



to change-x1-index [ amount ]
   set x1-index ( min (list x1-index-max ( max (list x1-index-min ( x1-index + amount ) ) ) ) )
end

to change-x2-index [ amount ]
   set x2-index ( min (list x2-index-max ( max (list x2-index-min ( x2-index + amount ) ) ) ) )
end

to change-markup% [ amount ]
   set markup% ( min (list markup%-max ( max (list markup%-min ( markup% + amount ) ) ) ) )
end

to-report +/- [ amount ]
   report ( amount * ( ( ( random 2 ) * 2 ) - 1 ) )
end
   





to-report select-on-probability [ choices chooser ]  ;;here the choices-list is an agentset

     ask choices
     [calculate-utility chooser
      calculate-probability
     ]
     let me nobody
     if None-option?
     [
       hatch-products 1
       [ 
        set probability e ^ [none_pw] of chooser
        set me self     
       ]
       set choices (turtle-set choices me)
     ]
     
     let choices-list sort choices
     set choices-list shuffle choices-list
   
     let total-prob sum map [ [ probability ] of ? ] choices-list
     ;; pick a random float in the range 0 .... total-prob
     let n random-float total-prob
     ;; start by considering the first member 
     let selected first choices-list
     ;; and the first member's probability
     let i [ probability ] of selected
     ;; until I exceeds the random n, keep scanning through the list
     while [ i < n ]
     [ ;; discard current item
       set choices-list but-first choices-list
       ;; get next item
       set selected first choices-list
       ;; increment I with the probability of the item
       set i i + [ probability ] of selected
     ]
     
     if None-option?
     [ if selected = me
       [set selected nobody ]
       ask me [die]
     ]
     
     
     report selected
end

to-report select-on-utility [ choices-list chooser ]  ;;here choices-list is an agentset


  ask choices-list
  [ calculate-utility chooser ]

  let selected max-one-of choices-list [ utility ]
  if None-option?
  [ if [utility] of selected < [none_pw] of chooser
    [set selected nobody]
    ;[report nobody]
    ;[report selected]
  ]
  report selected
end

to-report select-on-profit [ choices-list ]   ;;here input choices-list is a list

   set choices-list shuffle choices-list
   ;; calculate the total of all profit scores
   ;; get the max value of the population
   let selected nobody
   let max-p max [ profit ] of (turtle-set choices-list)
   ifelse max-p <= 0 
   [ set selected one-of choices-list ]
   [ let max-p-scale 1 / max-p
     ;; get the profit value from each member of the list, sum those values
     ;; divide by max-p so that max value is 1
     let new-choices-list sort (turtle-set choices-list) with [profit > 0]
     
     set choices-list new-choices-list
     
     let total-prob sum map [ [ profit * max-p-scale ] of ? ] choices-list
     ;; pick a random float in the range 0 .... total-prob
     let n random-float total-prob
     ;; start by considering the first member 
     set selected first choices-list
     ;; and the first member's profit
     let i [ profit * max-p-scale ] of selected
     ;; until I exceeds the random n, keep scanning through the list
     while [ i < n ]
     [ ;; discard current item
       set choices-list but-first choices-list
       ;; get next item
       set selected first choices-list
       ;; increment I with the probability of the item
       set i i + [ profit ] of selected * max-p-scale 
     ]
    ]
     report selected
end

to-report select-on-total-profit [ choices-list ]   ;;here input choices-list is a list

   set choices-list shuffle choices-list
   let selected nobody
   let max-p max [ total-profit ] of (turtle-set choices-list)
   ifelse max-p = 0 
   [ set selected one-of choices-list ]
   [ let max-p-scale 1 / max-p
     let total-prob sum map [ [ total-profit * max-p-scale ] of ? ] choices-list
     let n random-float total-prob
     set selected first choices-list
     let i [ total-profit * max-p-scale ] of selected
     while [ i < n ]
     [ 
       set choices-list but-first choices-list
       set selected first choices-list
       set i i + [ total-profit * max-p-scale ] of selected
     ]
    ]
     report selected
end

to-report select-on-total-utility [ choices-list ]   ;;here input choices-list is a list

   set choices-list shuffle choices-list
   let selected nobody
   let max-p max [ total-utility ] of (turtle-set choices-list)
   ifelse max-p = 0 
   [ set selected one-of choices-list ]
   [ let max-p-scale 1 / max-p
     let total-prob sum map [ [ total-utility * max-p-scale ] of ? ] choices-list
     let n random-float total-prob
     set selected first choices-list
     let i [ total-utility * max-p-scale ] of selected
     while [ i < n ]
     [ 
       set choices-list but-first choices-list
       set selected first choices-list
       set i i + [ total-utility * max-p-scale ] of selected
     ]
    ]
     report selected
end
  


   
@#$#@#$#@
GRAPHICS-WINDOW
769
10
969
201
-1
-1
10.0
1
10
1
1
1
0
0
0
1
-3
15
-3
12
1
1
1
ticks

CC-WINDOW
5
739
1003
834
Command Center
0

OUTPUT
192
10
749
200
12

BUTTON
5
273
80
306
setup
ca __setup__
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
5
10
177
43
market-size
market-size
10
7614
107
1
1
NIL
HORIZONTAL

BUTTON
5
313
80
346
go 1x
__go__
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
5
352
80
385
go(400x)
go_400
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SWITCH
844
459
934
492
output?
output?
0
1
-1000

BUTTON
5
392
80
425
go
ifelse experiment = \"CAFE+GreenFee\" or experiment = \"CAFE+Rebate\"\n[ifelse month < 151\n[__go__]\n[stop]\n]\n[ifelse month < 101\n[__go__]\n[stop]\n]
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
5
78
177
111
competitors
competitors
1
10
6
1
1
NIL
HORIZONTAL

TEXTBOX
6
469
116
487
Markup % over cost.
11
0.0
1

TEXTBOX
848
427
933
462
annual markup change (+/-)
11
0.0
1

INPUTBOX
5
488
78
548
markup%-min
0.1
1
0
Number

PLOT
516
360
833
519
Markup
NIL
NIL
0.0
10.0
0.0
5.0
true
true
PENS
"100%" 1.0 0 -16777216 true
"p1" 1.0 0 -13345367 true
"p2" 1.0 0 -13791810 true
"p3" 1.0 0 -10899396 true
"p4" 1.0 0 -13840069 true
"p5" 1.0 0 -955883 true
"p6" 1.0 0 -6459832 true

SLIDER
5
111
177
144
products-per-competitor
products-per-competitor
1
2
1
1
1
NIL
HORIZONTAL

PLOT
192
360
510
519
Sales
NIL
NIL
0.0
10.0
0.0
0.0
true
true
PENS
"p1" 1.0 0 -13345367 true
"p2" 1.0 0 -13791810 true
"p3" 1.0 0 -10899396 true
"p4" 1.0 0 -13840069 true
"p5" 1.0 0 -955883 true
"p6" 1.0 0 -6459832 true

PLOT
192
206
510
353
Market Share
NIL
NIL
0.0
10.0
0.0
1.0
true
true
PENS
"even" 1.0 0 -16777216 true
"p1" 1.0 0 -13345367 true
"p2" 1.0 0 -13791810 true
"p3" 1.0 0 -10899396 true
"p4" 1.0 0 -13840069 true
"p5" 1.0 0 -955883 true
"p6" 1.0 0 -6459832 true

SWITCH
844
499
994
532
variable-markup?
variable-markup?
0
1
-1000

MONITOR
844
207
991
252
Utility(gas): [ MIN MAX ]
(list precision min [ p-utility-g ] of grid-patches 5\n      precision max [ p-utility-g ] of grid-patches 5\n)
0
1
11

BUTTON
844
269
929
302
Utility
color-patches-by-utility
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

TEXTBOX
844
254
994
272
Color grid by...
11
0.0
1

BUTTON
844
309
944
342
Module Cost
patch.all-color-by-module-cost
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
844
349
929
382
Mpg<z1>
patch.all-color-by-mpg<z1>
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
844
389
949
422
Acceleration<z2>
patch.all-color-by-acc<z2>
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

INPUTBOX
90
488
162
548
markup%-max
1000
1
0
Number

CHOOSER
5
598
162
643
competition-strategy
competition-strategy
"drunken-ceo" "genetic-algorithm" "simulated-annealing"
2

CHOOSER
5
646
162
691
policy-choice
policy-choice
"none policy" "CAFE" "CO2 tax" "Both"
0

CHOOSER
86
351
178
396
social_network
social_network
"small-world" "scale-free"
1

PLOT
516
206
834
354
Profit
NIL
NIL
0.0
10.0
0.0
10.0
true
true
PENS
"zero" 1.0 0 -16777216 true
"p1" 1.0 0 -13345367 true
"p2" 1.0 0 -13791810 true
"p3" 1.0 0 -10899396 true
"p4" 1.0 0 -13840069 true
"p5" 1.0 0 -955883 true
"p6" 1.0 0 -6459832 true

SWITCH
5
434
118
467
change-car?
change-car?
0
1
-1000

SWITCH
86
312
178
345
network?
network?
1
1
-1000

CHOOSER
5
551
162
596
choice-method
choice-method
"first choice" "share of preference"
1

SLIDER
5
145
177
178
penalty
penalty
0
10000
1000
100
1
$/consumer
HORIZONTAL

BUTTON
88
274
177
307
Model V&V
V&V
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
5
44
177
77
sample-count
sample-count
0
7614
7614
1
1
NIL
HORIZONTAL

SWITCH
6
692
135
725
None-option?
None-option?
1
1
-1000

PLOT
192
522
510
672
Sales by Module
NIL
NIL
0.0
10.0
0.0
10.0
true
true
PENS
"GasolineSedan" 1.0 0 -13345367 true
"GasolineSUV" 1.0 0 -13791810 true
"HybridSedan" 1.0 0 -10899396 true
"HybridSUV" 1.0 0 -13840069 true
"ElectricSedan" 1.0 0 -955883 true
"ElectricSUV" 1.0 0 -6459832 true

SWITCH
630
15
745
48
output-profit?
output-profit?
0
1
-1000

CHOOSER
5
179
177
224
consumer-policy
consumer-policy
"Tax Rebate for Hybrid" "Tax Rebate for Electric" "Green Fee for SUV" "Green Fee for Gasoline" "None Policy"
4

CHOOSER
5
225
177
270
experiment
experiment
"Base Case" "CAFE" "Rebate" "GreenFee" "CAFE+GreenFee" "CAFE+Rebate"
0

SLIDER
86
397
178
430
beta
beta
0
1
0.5
0.01
1
NIL
HORIZONTAL

@#$#@#$#@
WHAT IS IT?
-----------
A set number of auto manufacturers compete to maximize profit by offering j different automobiles to consumers at price pj.  Each auto design has two variables x1j (engine scaling) and x2j (final drive ratio) that can be varied to increase consumer demand.  These designs drive costs, and thus profits.  Goal: 

maximize profit = (quantity sold*price) - cost = quantity sold(price -(body cost + engine cost)-initial investment) - regulation cost 

	 
with respect to (Mj, x1, x2, p) where Mj = SI102 (gasoline engine) or CI88 (diesel engine), x1 = [0.75, 1.50], x2 = [0.2, 2.0] and pj = [cost+0.1%, cost+100%]

This model replicates the economic model developed by Michalek, Papalambros, and Skerlos (2004), A study of the fuel efficiency and emission policy impact on optimal vehicle design decisions, Transactions of the ASME.
	   
HOW DOES IT WORK?
------------

Producers of autos maximize profits while consumers maximize utility by purchasing the vehicle that best meets their needs (note that in this version of the model (0017_v8) the consumers are homogeneous).

Different regulation policies ('policy choice' drop down menu in interface) are modeled to determine how policies impact auto manufacturing decisions.  

The output is the optimal product design for the manufacturer with regulation costs and retail price calculated.  An example of the output is;

scale ratio (x1/x2/markup/engine):    1.5//1.2//57.49//diesel
accel/mpg(z1/z2):        21.3408//6.9406
unit mfg cost / regulation cost / retail price:   $12762.54  // $1488.91 // $20100.2


HOW TO USE IT
----------------

This section could explain how to use the model, 

sliders (default setting):
* market-size (1570000) - number of consumers buying in the 'marketspace'.
* agent-scale (2) - number of consumers each agent represents
* competitors (10) - number of firms competing in the 'marketspace'.
* products-per-competitor (1) - number of products each producer can produce, by now we set it 1

buttons:
* setup - to initiate consumers and manufacturers
* go 1x - one period
* go (1000x) - 1000 periods
* go - program continues running until 'go' button is hit again.  

Input:

* markup%_min - the lower limit of the markup, need save the program after input to make it work
* markup%_max - the upper limit of the markup, need save the program after input to make it work

choosers:
* competition strategy (choices: drunken ceo, genetic algorithm, simulated-annealing):   - The drunken ceo is a random method of searching for profit maximization. 

 - Genetic algorithm to determine Nash equilibrium (point where all firms maximize profit)
 - Simulated annealing to determine Nash equilibrium (point where all firms maximize profit)
 
   
* policy-choice (choices, no policy, CAFE, CO2 tax, Both):
  - no policy - no policies imposed

  - CAFE- penalties of $55 per vehicle per mpg under the 27.5 CAFE limit is imposed. 
 
  - C02 tax- penalties for a gas engine is set at  23 * 150,000 * .00994 / z1 and           penalties for a diesel engine is set at 23 * 150,000 * 0.00921 / z1, where z1 is        the gas mileage associated with a specific x1 (engine scaling) and x2 (final drive      ratio).
  - Both - both CAFE and CO2 tax policies at the same

Sliders (default setting):
- beta1.mean - the mean of the beta1 value of consumer perference
- beta2.mean - the mean of the beta2 value of consumer perference
- beta3.mean - the mean of the beta3 value of consumer perference

- beta1.mean.group2 - if we want to silulate 2 groups of consumer, the mean of the beta1 value of group 2 consumer perference
- beta2.mean.group2 - if we want to silulate 2 groups of consumer, the mean of the beta1 value of group 2 consumer perference
- beta3.mean.group2 - if we want to silulate 2 groups of consumer, the mean of the beta1 value of group 2 consumer perference

- beta1.sd - standard deviation of beta1 of consumer perference, here equal to 0 because the consumers are homogeneous
- beta2.sd - standard deviation of beta2 of consumer perference, here equal to 0 because the consumers are homogeneous
- beta3.sd - standard deviation of beta3 of consumer perference, here equal to 0 because the consumers are homogeneous

THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.

In the interface, the blue dots mean the gasoline engine vehicle, yellow dots mean the diesel engine vehicel, the red dot is the Nash equilibrium.

When all the variables and initial conditions are set exactly the same with Michalek, Papalambros, and Skerlos (2004)'s model, the Nash equilibrium as shown with the red dot can be achieved. But if one or more of the variables have been changed, the equilibrium point may will also change.

Engine cost: diesel engine cost is significantly higher than gasoline engine.


THINGS TO TRY
----------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.

Different competition stratigies:
Both Genetic Algorithm and Simulated Annealing can achieve the Nash equalibrium. The drunk CEO stratigy can not achieve the equalibrium.

Choose different emission policies:
Four options:
 None, CAFE, CO2 emission Tax, Both CAFE and CO2 Tax

Change the consumer attributes by slide the attributes sliders.:
By now only the sliders of mean work becasue the consumers are homogeneous.
The consumers can be set as two groups with different attributes.

Change the range of markup by input lower and upper limit of markup.


NOTES
-------------
Summary of Model
Aug-11-08


Global Constants
----------------
 *CI = $550 x 10^6 ;; design INTEGRATION COST?
 *CB = $7500  ;; BASE UNIT  COST
 *CRK  = 0 (for now)
 *Constant beta4 = 670.51
 *Constant beta5 = 0.0063
 *Constant beta6 = 26.23
 *Constant beta7 = 1642.8
 *preference variable constant beta1 = -2.86 x 10-4
 *preference variable constant beta2 = -0.339
 *preference variable constant beta3 = 0.375

 *Market size s = 1.57 x 10^6  ;; number of consumers
 *bSI102 = 102 kW ;; basic size of engine SI102
 *bCI88 = 90.5 kW ;; basic size of engine CI88

Global variables
----------------
 *market-size (1570000) - number of consumers buying in the 'marketspace'.
 *agent-scale (2) - number of consumers each agent represents
 *competitors (10) - number of firms competing in the 'marketspace'.
 *products-per-competitor (1) - number of products each producer can produce, by now we set it 1

Agent Instantiation
-------------------
	Producer Attributes:
		Producer ID: unique id [1, k].
 *Engine type M : will take a value of either SI102 or CI88
 *Engine variable x1j 
 *Engine variable x2j
 *Performance characteristic1  z1j
 *Performance characteristic2  z2j
 *Revenue: initialized to 0
 *Profit: initialized to 0
 *The total number of gasoline engines sold by producer: initialized to 0
 *The total number of diesel engines sold by producer:  initialized to 0
 Consumer Attributes:
 *Consumer ID: unique id [1,q]
 *Consumer utility vij: initilized to 0 for each consumer agent for each design, j
	   
Vehicle Design Decision Module for each j vehicle design
	For each Producer:

	At initial, producers select engine type randomly.

Based on M:
*  (Initially?) Randomly choose x1j (engine scaling) from range [0.75 , 1.50];  increments of 0.125
*  (Initially) Randomly choose x2j (final drive ratio) from range [0.2 , 2.0]; increments of 0.10
*  Look up values for z1 and z2 from the lookup table that maps x1j to z1j (MPG) and x2 j to z2 j  (ACC).

*  pj(0) (price for design j); initial price = $14,000
	   

*10	Consumer Module	For each consumer calculate utilities for each design, j, and expected demand is obtained for each design j 

[initial model j = 1 for each producer, by now set it 1, but can also set more than one which means each producer can produce not only one products. 

For each design:  
Calculate the cost based on the engine type:
1) For Engine type M = SI102,
          c E =  beta4 * exp ( beta5 * bSI102 * x1j )
          Cost = beta4 * exp ( beta4 * power * x1)

2) For Engine type M = CI88
          c E =  beta6 * ( bCI88 * x1 )  + beta7	
          cost = beta5 * ( power * x1 ) + beta 7 

  
*Producer Revenue Module	quantity sale * price

*Producer profit equalt to revenue minus cost

Consumer utility calculation:

*Utility = beta1 * price + beta2 * 100 / z1 + beta3 * 60 / z2


   
Equilibrium	In each round, producer k , assumes competitions product is set.  Producer k will vary its design and price (markup) to maximize profit.  When each producer does not vary the design or the price from the previous round, equilibrium is set.  	 

CREDITS AND REFERENCES
-----------------------
Rosanna Garcia and Samer Balbaky, Vehicle Choice Decision Making:  What Factors Impact Consumer Choice for Automobile Purchases?:  A Literature Review, Northeastern University, Working Paper 01-2007.
Jeremy J. Michalek, Panos Y. Paplambros, and Steven J. Skerlos, A study of fuel efficiency and emission policy impact on optimal vehicle design decisions, Transactions of the ASME, Vol 126, November 2004, 1062-1070.  

@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

blank
false
0

car side
false
0
Polygon -7500403 true true 19 147 11 125 16 105 63 105 99 79 155 79 180 105 243 111 266 129 253 149
Circle -16777216 true false 43 123 42
Circle -16777216 true false 194 124 42
Polygon -16777216 true false 101 87 73 108 171 108 151 87
Line -8630108 false 121 82 120 108
Polygon -1 true false 242 121 248 128 266 129 247 115
Rectangle -16777216 true false 12 131 28 143

dot
false
0
Circle -7500403 true true 120 120 60

van side
false
0
Polygon -7500403 true true 26 147 18 125 36 61 161 61 177 67 195 90 242 97 262 110 273 129 260 149
Circle -16777216 true false 43 123 42
Circle -16777216 true false 194 124 42
Polygon -16777216 true false 45 68 37 95 183 96 169 69
Line -7500403 true 62 65 62 103
Line -7500403 true 115 68 120 100
Polygon -1 true false 271 127 258 126 257 114 261 109
Rectangle -16777216 true false 19 131 27 142

@#$#@#$#@
NetLogo 4.0.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="Test1" repetitions="1" runMetricsEveryStep="false">
    <timeLimit steps="2"/>
    <metric>report name</metric>
    <metric>report fuel</metric>
    <metric>report cartype</metric>
    <metric>report units-sold</metric>
    <enumeratedValueSet variable="choice-method">
      <value value="&quot;first choice&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="policy-choice">
      <value value="&quot;none policy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="market-size">
      <value value="1011"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="markup%-min">
      <value value="0.1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="markup%-max">
      <value value="500"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="change-car?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="network?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="output?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="penalty">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="competitors">
      <value value="6"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="competition-strategy">
      <value value="&quot;simulated-annealing&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="products-per-competitor">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="variable-markup?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="social_network">
      <value value="&quot;small-world&quot;"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
